#!/bin/sh -x

OS=`uname -s`
ARCH=`uname -m`

TOPDIR="xts5-${OS}-${ARCH}"
mkdir ${TOPDIR}
cd ${TOPDIR}

#
# Get tet source and build it.
#
wget http://tetworks.opengroup.org/tet/tet3.3h-unsup.src.tgz
tar zxf tet3.3h-unsup.src.tgz
rm -f tet3.3h-unsup.src.tgz

TET_ROOT=`pwd`
export TET_ROOT
PATH=${TET_ROOT}/bin:${TET_ROOT}/xts5/bin:${PATH}
export PATH

sh configure -t lite
cd src
make install
make compat
cd ..

#
# Longer term, we want to get this as a source tarball instead of from CVS.
#
cvs -z3 -d:pserver:anoncvs@cvs.freedesktop.org:/cvs/xtest login
cvs -z3 -d:pserver:anoncvs@cvs.freedesktop.org:/cvs/xtest co xts5 utils
ln -s utils/xreg xreg
ln -s xts5 vsw5
cd xts5

#
# Later, make this a bit smarter to hadle different OSes
#
chmod +w tetbuild.cfg
cp configs/tetbuild.cfg.${OS} ./tetbuild.cfg

make
(cd fonts;make comp_pcf)
tcc -b

#
# Clean up a couple of things and produce a tarball
#
rm -rf results/* 
cd ../..
tar czf ${TOPDIR}.tgz ${TOPDIR}
