/*
Copyright (c) 2005 X.Org Foundation L.L.C.

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
/*
* $Header: /cvs/xtest/xtest/xts5/fonts/xtfont2.c,v 1.2 2005/11/03 08:42:00 jmichael Exp $
*
* Copyright (c) Applied Testing and Technology, Inc. 1995
* All Rights Reserved.
*
* Project:     VSW5
*
* File:        xts5/fonts/xtfont2.c
*
* Description:
*	VSW test font
*
* Modifications:
* $Log: xtfont2.c,v $
* Revision 1.2  2005/11/03 08:42:00  jmichael
* clean up all vsw5 paths to use xts5 instead.
*
* Revision 1.1.1.2  2005/04/15 14:05:06  anderson
* Reimport of the base with the legal name in the copyright fixed.
*
* Revision 8.0  1998/12/23 23:22:52  mar
* Branch point for Release 5.0.2
*
* Revision 7.0  1998/10/30 22:40:52  mar
* Branch point for Release 5.0.2b1
*
* Revision 6.0  1998/03/02 05:15:26  tbr
* Branch point for Release 5.0.1
*
* Revision 5.0  1998/01/26 03:11:58  tbr
* Branch point for Release 5.0.1b1
*
* Revision 4.1  1996/01/25 02:01:11  andy
* Portability improvements from DEPLOY tools
*
* Revision 4.0  1995/12/15  08:37:47  tbr
* Branch point for Release 5.0.0
*
* Revision 3.1  1995/12/15  00:33:38  andy
* Prepare for GA Release
*
*/

/*
Portions of this software are based on Xlib and X Protocol Test Suite.
We have used this material under the terms of its copyright, which grants
free use, subject to the conditions below.  Note however that those
portions of this software that are based on the original Test Suite have
been significantly revised and that all such revisions are copyright (c)
1995 Applied Testing and Technology, Inc.  Insomuch as the proprietary
revisions cannot be separated from the freely copyable material, the net
result is that use of this software is governed by the ApTest copyright.

Copyright (c) 1990, 1991  X Consortium

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of the X Consortium shall not be
used in advertising or otherwise to promote the sale, use or other dealings
in this Software without prior written authorization from the X Consortium.

Copyright 1990, 1991 by UniSoft Group Limited.

Permission to use, copy, modify, distribute, and sell this software and
its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of UniSoft not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  UniSoft
makes no representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.
 */

#include	"xtest.h"
#include	"X11/Xlib.h"
#include	"X11/Xutil.h"
#include	"X11/Xatom.h"

static XCharStruct perchar[] = {
	{0, 0, 14, 0, 0, 0},	/* 8481 */
	{1, 5, 14, 2, 2, 0},	/* 8482 */
	{1, 5, 14, 2, 2, 0},	/* 8483 */
	{1, 3, 14, 2, 2, 0},	/* 8484 */
	{1, 3, 14, 1, 1, 0},	/* 8485 */
	{5, 9, 14, 7, -3, 0},	/* 8486 */
	{6, 8, 14, 9, -2, 0},	/* 8487 */
	{6, 8, 14, 9, 0, 0},	/* 8488 */
	{4, 11, 14, 11, 2, 0},	/* 8489 */
	{6, 9, 14, 12, 2, 0},	/* 8490 */
	{1, 5, 14, 12, -9, 0},	/* 8491 */
	{1, 5, 14, 12, -8, 0},	/* 8492 */
	{5, 9, 14, 12, -9, 0},	/* 8493 */
	{5, 9, 14, 12, -9, 0},	/* 8494 */
	{4, 11, 14, 12, -10, 0},	/* 8495 */
	{4, 11, 14, 12, -8, 0},	/* 8496 */
	{0, 14, 14, 12, -11, 0},	/* 8497 */
	{0, 14, 14, -1, 2, 0},	/* 8498 */
	{4, 11, 14, 8, -3, 0},	/* 8499 */
	{4, 12, 14, 10, -3, 0},	/* 8500 */
	{4, 10, 14, 8, -3, 0},	/* 8501 */
	{4, 12, 14, 10, -3, 0},	/* 8502 */
	{3, 10, 14, 8, -2, 0},	/* 8503 */
	{1, 14, 14, 12, 1, 0},	/* 8504 */
	{3, 12, 14, 8, 2, 0},	/* 8505 */
	{2, 12, 14, 10, 1, 0},	/* 8506 */
	{1, 14, 14, 11, 2, 0},	/* 8507 */
	{1, 13, 14, 6, -4, 0},	/* 8508 */
	{0, 14, 14, 6, -5, 0},	/* 8509 */
	{5, 10, 14, 6, -5, 0},	/* 8510 */
	{0, 14, 14, 12, 2, 0},	/* 8511 */
	{0, 14, 14, 12, 2, 0},	/* 8512 */
	{1, 13, 14, 7, -3, 0},	/* 8513 */
	{5, 9, 14, 12, 2, 0},	/* 8514 */
	{7, 8, 14, 12, 2, 0},	/* 8515 */
	{2, 12, 14, 6, -4, 0},	/* 8516 */
	{3, 11, 14, 6, -4, 0},	/* 8517 */
	{10, 13, 14, 12, -7, 0},	/* 8518 */
	{1, 4, 14, 12, -7, 0},	/* 8519 */
	{6, 13, 14, 12, -7, 0},	/* 8520 */
	{1, 8, 14, 12, -7, 0},	/* 8521 */
	{8, 13, 14, 12, 2, 0},	/* 8522 */
	{1, 6, 14, 12, 2, 0},	/* 8523 */
	{9, 13, 14, 12, 2, 0},	/* 8524 */
	{1, 5, 14, 12, 2, 0},	/* 8525 */
	{8, 13, 14, 12, 2, 0},	/* 8526 */
	{1, 6, 14, 12, 2, 0},	/* 8527 */
	{7, 13, 14, 12, 2, 0},	/* 8528 */
	{1, 7, 14, 12, 2, 0},	/* 8529 */
	{6, 13, 14, 12, 2, 0},	/* 8530 */
	{1, 8, 14, 12, 2, 0},	/* 8531 */
	{6, 13, 14, 12, 2, 0},	/* 8532 */
	{1, 8, 14, 12, 2, 0},	/* 8533 */
	{7, 13, 14, 12, 2, 0},	/* 8534 */
	{1, 7, 14, 12, 2, 0},	/* 8535 */
	{6, 13, 14, 12, 2, 0},	/* 8536 */
	{1, 8, 14, 12, 2, 0},	/* 8537 */
	{8, 13, 14, 12, 2, 0},	/* 8538 */
	{1, 6, 14, 12, 2, 0},	/* 8539 */
	{2, 13, 14, 11, 1, 0},	/* 8540 */
	{2, 13, 14, 6, -5, 0},	/* 8541 */
	{2, 13, 14, 11, 0, 0},	/* 8542 */
	{2, 13, 14, 11, 0, 0},	/* 8543 */
	{2, 13, 14, 11, 0, 0},	/* 8544 */
	{2, 13, 14, 8, -3, 0},	/* 8545 */
	{2, 13, 14, 11, 0, 0},	/* 8546 */
	{2, 12, 14, 12, 1, 0},	/* 8547 */
	{2, 12, 14, 12, 1, 0},	/* 8548 */
	{2, 13, 14, 12, 1, 0},	/* 8549 */
	{2, 13, 14, 12, 1, 0},	/* 8550 */
	{2, 13, 14, 8, -2, 0},	/* 8551 */
	{2, 13, 14, 10, 0, 0},	/* 8552 */
	{1, 13, 14, 11, 1, 0},	/* 8553 */
	{3, 12, 14, 11, 2, 0},	/* 8554 */
	{2, 6, 14, 11, -7, 0},	/* 8555 */
	{1, 5, 14, 11, -6, 0},	/* 8556 */
	{1, 8, 14, 11, -6, 0},	/* 8557 */
	{1, 13, 14, 11, 1, 0},	/* 8558 */
	{1, 13, 14, 11, 1, 0},	/* 8559 */
	{3, 12, 14, 11, 2, 0},	/* 8560 */
	{3, 11, 14, 11, 2, 0},	/* 8561 */
	{1, 13, 14, 11, 1, 0},	/* 8562 */
	{1, 13, 14, 11, 1, 0},	/* 8563 */
	{2, 13, 14, 11, 2, 0},	/* 8564 */
	{2, 13, 14, 11, 1, 0},	/* 8565 */
	{3, 12, 14, 10, 0, 0},	/* 8566 */
	{1, 13, 14, 11, 1, 0},	/* 8567 */
	{5, 10, 14, 12, 2, 0},	/* 8568 */
	{1, 14, 14, 11, 1, 0},	/* 8569 */
	{1, 14, 14, 11, 1, 0},	/* 8570 */
	{2, 13, 14, 10, 1, 0},	/* 8571 */
	{2, 13, 14, 10, 1, 0},	/* 8572 */
	{2, 13, 14, 10, 1, 0},	/* 8573 */
	{1, 14, 14, 11, 2, 0},	/* 8574 */
	{0, 0, 0, 0, 0, 0},	/* 8737 */
	{0, 0, 0, 0, 0, 0},	/* 8738 */
	{0, 0, 0, 0, 0, 0},	/* 8739 */
	{0, 0, 0, 0, 0, 0},	/* 8740 */
	{0, 0, 0, 0, 0, 0},	/* 8741 */
	{0, 0, 0, 0, 0, 0},	/* 8742 */
	{0, 0, 0, 0, 0, 0},	/* 8743 */
	{0, 0, 0, 0, 0, 0},	/* 8744 */
	{0, 0, 0, 0, 0, 0},	/* 8745 */
	{0, 0, 0, 0, 0, 0},	/* 8746 */
	{0, 0, 0, 0, 0, 0},	/* 8747 */
	{0, 0, 0, 0, 0, 0},	/* 8748 */
	{0, 0, 0, 0, 0, 0},	/* 8749 */
	{0, 0, 0, 0, 0, 0},	/* 8750 */
	{0, 0, 0, 0, 0, 0},	/* 8751 */
	{0, 0, 0, 0, 0, 0},	/* 8752 */
	{0, 0, 0, 0, 0, 0},	/* 8753 */
	{0, 0, 0, 0, 0, 0},	/* 8754 */
	{0, 0, 0, 0, 0, 0},	/* 8755 */
	{0, 0, 0, 0, 0, 0},	/* 8756 */
	{0, 0, 0, 0, 0, 0},	/* 8757 */
	{0, 0, 0, 0, 0, 0},	/* 8758 */
	{0, 0, 0, 0, 0, 0},	/* 8759 */
	{0, 0, 0, 0, 0, 0},	/* 8760 */
	{0, 0, 0, 0, 0, 0},	/* 8761 */
	{0, 0, 0, 0, 0, 0},	/* 8762 */
	{0, 0, 0, 0, 0, 0},	/* 8763 */
	{0, 0, 0, 0, 0, 0},	/* 8764 */
	{0, 0, 0, 0, 0, 0},	/* 8765 */
	{0, 0, 0, 0, 0, 0},	/* 8766 */
	{0, 0, 0, 0, 0, 0},	/* 8767 */
	{0, 0, 0, 0, 0, 0},	/* 8768 */
	{0, 0, 0, 0, 0, 0},	/* 8769 */
	{0, 0, 0, 0, 0, 0},	/* 8770 */
	{0, 0, 0, 0, 0, 0},	/* 8771 */
	{0, 0, 0, 0, 0, 0},	/* 8772 */
	{0, 0, 0, 0, 0, 0},	/* 8773 */
	{0, 0, 0, 0, 0, 0},	/* 8774 */
	{0, 0, 0, 0, 0, 0},	/* 8775 */
	{0, 0, 0, 0, 0, 0},	/* 8776 */
	{0, 0, 0, 0, 0, 0},	/* 8777 */
	{0, 0, 0, 0, 0, 0},	/* 8778 */
	{0, 0, 0, 0, 0, 0},	/* 8779 */
	{0, 0, 0, 0, 0, 0},	/* 8780 */
	{0, 0, 0, 0, 0, 0},	/* 8781 */
	{0, 0, 0, 0, 0, 0},	/* 8782 */
	{0, 0, 0, 0, 0, 0},	/* 8783 */
	{0, 0, 0, 0, 0, 0},	/* 8784 */
	{0, 0, 0, 0, 0, 0},	/* 8785 */
	{0, 0, 0, 0, 0, 0},	/* 8786 */
	{0, 0, 0, 0, 0, 0},	/* 8787 */
	{0, 0, 0, 0, 0, 0},	/* 8788 */
	{0, 0, 0, 0, 0, 0},	/* 8789 */
	{0, 0, 0, 0, 0, 0},	/* 8790 */
	{0, 0, 0, 0, 0, 0},	/* 8791 */
	{0, 0, 0, 0, 0, 0},	/* 8792 */
	{0, 0, 0, 0, 0, 0},	/* 8793 */
	{0, 0, 0, 0, 0, 0},	/* 8794 */
	{0, 0, 0, 0, 0, 0},	/* 8795 */
	{0, 0, 0, 0, 0, 0},	/* 8796 */
	{0, 0, 0, 0, 0, 0},	/* 8797 */
	{0, 0, 0, 0, 0, 0},	/* 8798 */
	{0, 0, 0, 0, 0, 0},	/* 8799 */
	{0, 0, 0, 0, 0, 0},	/* 8800 */
	{0, 0, 0, 0, 0, 0},	/* 8801 */
	{0, 0, 0, 0, 0, 0},	/* 8802 */
	{0, 0, 0, 0, 0, 0},	/* 8803 */
	{0, 0, 0, 0, 0, 0},	/* 8804 */
	{0, 0, 0, 0, 0, 0},	/* 8805 */
	{0, 0, 0, 0, 0, 0},	/* 8806 */
	{0, 0, 0, 0, 0, 0},	/* 8807 */
	{0, 0, 0, 0, 0, 0},	/* 8808 */
	{0, 0, 0, 0, 0, 0},	/* 8809 */
	{0, 0, 0, 0, 0, 0},	/* 8810 */
	{0, 0, 0, 0, 0, 0},	/* 8811 */
	{0, 0, 0, 0, 0, 0},	/* 8812 */
	{0, 0, 0, 0, 0, 0},	/* 8813 */
	{0, 0, 0, 0, 0, 0},	/* 8814 */
	{0, 0, 0, 0, 0, 0},	/* 8815 */
	{0, 0, 0, 0, 0, 0},	/* 8816 */
	{0, 0, 0, 0, 0, 0},	/* 8817 */
	{0, 0, 0, 0, 0, 0},	/* 8818 */
	{0, 0, 0, 0, 0, 0},	/* 8819 */
	{0, 0, 0, 0, 0, 0},	/* 8820 */
	{0, 0, 0, 0, 0, 0},	/* 8821 */
	{0, 0, 0, 0, 0, 0},	/* 8822 */
	{0, 0, 0, 0, 0, 0},	/* 8823 */
	{0, 0, 0, 0, 0, 0},	/* 8824 */
	{0, 0, 0, 0, 0, 0},	/* 8825 */
	{0, 0, 0, 0, 0, 0},	/* 8826 */
	{0, 0, 0, 0, 0, 0},	/* 8827 */
	{0, 0, 0, 0, 0, 0},	/* 8828 */
	{0, 0, 0, 0, 0, 0},	/* 8829 */
	{0, 0, 0, 0, 0, 0},	/* 8830 */
	{0, 0, 0, 0, 0, 0},	/* 8993 */
	{0, 0, 0, 0, 0, 0},	/* 8994 */
	{0, 0, 0, 0, 0, 0},	/* 8995 */
	{0, 0, 0, 0, 0, 0},	/* 8996 */
	{0, 0, 0, 0, 0, 0},	/* 8997 */
	{0, 0, 0, 0, 0, 0},	/* 8998 */
	{0, 0, 0, 0, 0, 0},	/* 8999 */
	{0, 0, 0, 0, 0, 0},	/* 9000 */
	{0, 0, 0, 0, 0, 0},	/* 9001 */
	{0, 0, 0, 0, 0, 0},	/* 9002 */
	{0, 0, 0, 0, 0, 0},	/* 9003 */
	{0, 0, 0, 0, 0, 0},	/* 9004 */
	{0, 0, 0, 0, 0, 0},	/* 9005 */
	{0, 0, 0, 0, 0, 0},	/* 9006 */
	{0, 0, 0, 0, 0, 0},	/* 9007 */
	{0, 0, 0, 0, 0, 0},	/* 9008 */
	{0, 0, 0, 0, 0, 0},	/* 9009 */
	{0, 0, 0, 0, 0, 0},	/* 9010 */
	{0, 0, 0, 0, 0, 0},	/* 9011 */
	{0, 0, 0, 0, 0, 0},	/* 9012 */
	{0, 0, 0, 0, 0, 0},	/* 9013 */
	{0, 0, 0, 0, 0, 0},	/* 9014 */
	{0, 0, 0, 0, 0, 0},	/* 9015 */
	{0, 0, 0, 0, 0, 0},	/* 9016 */
	{0, 0, 0, 0, 0, 0},	/* 9017 */
	{0, 0, 0, 0, 0, 0},	/* 9018 */
	{0, 0, 0, 0, 0, 0},	/* 9019 */
	{0, 0, 0, 0, 0, 0},	/* 9020 */
	{0, 0, 0, 0, 0, 0},	/* 9021 */
	{0, 0, 0, 0, 0, 0},	/* 9022 */
	{0, 0, 0, 0, 0, 0},	/* 9023 */
	{0, 0, 0, 0, 0, 0},	/* 9024 */
	{0, 0, 0, 0, 0, 0},	/* 9025 */
	{0, 0, 0, 0, 0, 0},	/* 9026 */
	{0, 0, 0, 0, 0, 0},	/* 9027 */
	{0, 0, 0, 0, 0, 0},	/* 9028 */
	{0, 0, 0, 0, 0, 0},	/* 9029 */
	{0, 0, 0, 0, 0, 0},	/* 9030 */
	{0, 0, 0, 0, 0, 0},	/* 9031 */
	{0, 0, 0, 0, 0, 0},	/* 9032 */
	{0, 0, 0, 0, 0, 0},	/* 9033 */
	{0, 0, 0, 0, 0, 0},	/* 9034 */
	{0, 0, 0, 0, 0, 0},	/* 9035 */
	{0, 0, 0, 0, 0, 0},	/* 9036 */
	{0, 0, 0, 0, 0, 0},	/* 9037 */
	{0, 0, 0, 0, 0, 0},	/* 9038 */
	{0, 0, 0, 0, 0, 0},	/* 9039 */
	{0, 0, 0, 0, 0, 0},	/* 9040 */
	{0, 0, 0, 0, 0, 0},	/* 9041 */
	{0, 0, 0, 0, 0, 0},	/* 9042 */
	{0, 0, 0, 0, 0, 0},	/* 9043 */
	{0, 0, 0, 0, 0, 0},	/* 9044 */
	{0, 0, 0, 0, 0, 0},	/* 9045 */
	{0, 0, 0, 0, 0, 0},	/* 9046 */
	{0, 0, 0, 0, 0, 0},	/* 9047 */
	{0, 0, 0, 0, 0, 0},	/* 9048 */
	{0, 0, 0, 0, 0, 0},	/* 9049 */
	{0, 0, 0, 0, 0, 0},	/* 9050 */
	{0, 0, 0, 0, 0, 0},	/* 9051 */
	{0, 0, 0, 0, 0, 0},	/* 9052 */
	{0, 0, 0, 0, 0, 0},	/* 9053 */
	{0, 0, 0, 0, 0, 0},	/* 9054 */
	{0, 0, 0, 0, 0, 0},	/* 9055 */
	{0, 0, 0, 0, 0, 0},	/* 9056 */
	{0, 0, 0, 0, 0, 0},	/* 9057 */
	{0, 0, 0, 0, 0, 0},	/* 9058 */
	{0, 0, 0, 0, 0, 0},	/* 9059 */
	{0, 0, 0, 0, 0, 0},	/* 9060 */
	{0, 0, 0, 0, 0, 0},	/* 9061 */
	{0, 0, 0, 0, 0, 0},	/* 9062 */
	{0, 0, 0, 0, 0, 0},	/* 9063 */
	{0, 0, 0, 0, 0, 0},	/* 9064 */
	{0, 0, 0, 0, 0, 0},	/* 9065 */
	{0, 0, 0, 0, 0, 0},	/* 9066 */
	{0, 0, 0, 0, 0, 0},	/* 9067 */
	{0, 0, 0, 0, 0, 0},	/* 9068 */
	{0, 0, 0, 0, 0, 0},	/* 9069 */
	{0, 0, 0, 0, 0, 0},	/* 9070 */
	{0, 0, 0, 0, 0, 0},	/* 9071 */
	{0, 0, 0, 0, 0, 0},	/* 9072 */
	{0, 0, 0, 0, 0, 0},	/* 9073 */
	{0, 0, 0, 0, 0, 0},	/* 9074 */
	{0, 0, 0, 0, 0, 0},	/* 9075 */
	{0, 0, 0, 0, 0, 0},	/* 9076 */
	{0, 0, 0, 0, 0, 0},	/* 9077 */
	{0, 0, 0, 0, 0, 0},	/* 9078 */
	{0, 0, 0, 0, 0, 0},	/* 9079 */
	{0, 0, 0, 0, 0, 0},	/* 9080 */
	{0, 0, 0, 0, 0, 0},	/* 9081 */
	{0, 0, 0, 0, 0, 0},	/* 9082 */
	{0, 0, 0, 0, 0, 0},	/* 9083 */
	{0, 0, 0, 0, 0, 0},	/* 9084 */
	{0, 0, 0, 0, 0, 0},	/* 9085 */
	{0, 0, 0, 0, 0, 0},	/* 9086 */
	{2, 12, 14, 9, 2, 0},	/* 9249 */
	{2, 13, 14, 12, 1, 0},	/* 9250 */
	{3, 12, 14, 6, 1, 0},	/* 9251 */
	{1, 13, 14, 9, 0, 0},	/* 9252 */
	{3, 10, 14, 8, 2, 0},	/* 9253 */
	{3, 11, 14, 12, 2, 0},	/* 9254 */
	{3, 12, 14, 8, 2, 0},	/* 9255 */
	{2, 13, 14, 12, 1, 0},	/* 9256 */
	{2, 12, 14, 8, 2, 0},	/* 9257 */
	{2, 14, 14, 11, 1, 0},	/* 9258 */
	{1, 13, 14, 11, 1, 0},	/* 9259 */
	{1, 14, 14, 12, 1, 0},	/* 9260 */
	{3, 12, 14, 12, 2, 0},	/* 9261 */
	{2, 14, 14, 12, 2, 0},	/* 9262 */
	{4, 10, 14, 12, 2, 0},	/* 9263 */
	{4, 14, 14, 12, 2, 0},	/* 9264 */
	{2, 14, 14, 12, 2, 0},	/* 9265 */
	{1, 14, 14, 12, 2, 0},	/* 9266 */
	{2, 12, 14, 11, 1, 0},	/* 9267 */
	{2, 14, 14, 12, 1, 0},	/* 9268 */
	{2, 12, 14, 12, 1, 0},	/* 9269 */
	{2, 14, 14, 12, 1, 0},	/* 9270 */
	{3, 13, 14, 11, 1, 0},	/* 9271 */
	{3, 13, 14, 11, 1, 0},	/* 9272 */
	{1, 13, 14, 12, 2, 0},	/* 9273 */
	{1, 14, 14, 12, 2, 0},	/* 9274 */
	{1, 13, 14, 11, 1, 0},	/* 9275 */
	{1, 14, 14, 12, 1, 0},	/* 9276 */
	{2, 13, 14, 11, 2, 0},	/* 9277 */
	{2, 14, 14, 11, 2, 0},	/* 9278 */
	{2, 13, 14, 11, 1, 0},	/* 9279 */
	{2, 14, 14, 12, 1, 0},	/* 9280 */
	{1, 12, 14, 12, 2, 0},	/* 9281 */
	{1, 14, 14, 12, 2, 0},	/* 9282 */
	{2, 12, 14, 6, 2, 0},	/* 9283 */
	{1, 13, 14, 9, 0, 0},	/* 9284 */
	{1, 14, 14, 12, 0, 0},	/* 9285 */
	{1, 13, 14, 11, 1, 0},	/* 9286 */
	{1, 14, 14, 11, 1, 0},	/* 9287 */
	{3, 12, 14, 11, 1, 0},	/* 9288 */
	{3, 14, 14, 11, 1, 0},	/* 9289 */
	{2, 13, 14, 12, 2, 0},	/* 9290 */
	{2, 13, 14, 11, 2, 0},	/* 9291 */
	{1, 13, 14, 11, 1, 0},	/* 9292 */
	{1, 13, 14, 12, 1, 0},	/* 9293 */
	{2, 13, 14, 10, 1, 0},	/* 9294 */
	{2, 13, 14, 12, 1, 0},	/* 9295 */
	{1, 14, 14, 12, 1, 0},	/* 9296 */
	{1, 14, 14, 12, 1, 0},	/* 9297 */
	{2, 13, 14, 11, 1, 0},	/* 9298 */
	{2, 14, 14, 12, 1, 0},	/* 9299 */
	{2, 13, 14, 12, 1, 0},	/* 9300 */
	{1, 14, 14, 11, 1, 0},	/* 9301 */
	{1, 14, 14, 11, 1, 0},	/* 9302 */
	{1, 14, 14, 11, 1, 0},	/* 9303 */
	{1, 14, 14, 8, -2, 0},	/* 9304 */
	{1, 14, 14, 10, -2, 0},	/* 9305 */
	{1, 14, 14, 11, -2, 0},	/* 9306 */
	{2, 13, 14, 11, 1, 0},	/* 9307 */
	{1, 14, 14, 11, 1, 0},	/* 9308 */
	{1, 14, 14, 12, 1, 0},	/* 9309 */
	{3, 12, 14, 12, 1, 0},	/* 9310 */
	{1, 14, 14, 11, 1, 0},	/* 9311 */
	{2, 14, 14, 12, 1, 0},	/* 9312 */
	{1, 13, 14, 11, 1, 0},	/* 9313 */
	{2, 12, 14, 12, 2, 0},	/* 9314 */
	{2, 12, 14, 8, 2, 0},	/* 9315 */
	{1, 13, 14, 12, 2, 0},	/* 9316 */
	{2, 12, 14, 8, 2, 0},	/* 9317 */
	{1, 13, 14, 11, 2, 0},	/* 9318 */
	{3, 11, 14, 9, 2, 0},	/* 9319 */
	{2, 12, 14, 12, 1, 0},	/* 9320 */
	{4, 12, 14, 12, 2, 0},	/* 9321 */
	{3, 11, 14, 12, 2, 0},	/* 9322 */
	{2, 12, 14, 11, 2, 0},	/* 9323 */
	{1, 14, 14, 11, 2, 0},	/* 9324 */
	{2, 12, 14, 11, 2, 0},	/* 9325 */
	{3, 12, 14, 8, 2, 0},	/* 9326 */
	{1, 13, 14, 12, 2, 0},	/* 9327 */
	{2, 13, 14, 11, 1, 0},	/* 9328 */
	{1, 13, 14, 11, 2, 0},	/* 9329 */
	{2, 13, 14, 12, 2, 0},	/* 9330 */
	{2, 13, 14, 12, 1, 0},	/* 9331 */
	{0, 0, 0, 0, 0, 0},	/* 9332 */
	{0, 0, 0, 0, 0, 0},	/* 9333 */
	{0, 0, 0, 0, 0, 0},	/* 9334 */
	{0, 0, 0, 0, 0, 0},	/* 9335 */
	{0, 0, 0, 0, 0, 0},	/* 9336 */
	{0, 0, 0, 0, 0, 0},	/* 9337 */
	{0, 0, 0, 0, 0, 0},	/* 9338 */
	{0, 0, 0, 0, 0, 0},	/* 9339 */
	{0, 0, 0, 0, 0, 0},	/* 9340 */
	{0, 0, 0, 0, 0, 0},	/* 9341 */
	{0, 0, 0, 0, 0, 0},	/* 9342 */
	{0, 0, 0, 0, 0, 0},	/* 9505 */
	{0, 0, 0, 0, 0, 0},	/* 9506 */
	{0, 0, 0, 0, 0, 0},	/* 9507 */
	{0, 0, 0, 0, 0, 0},	/* 9508 */
	{0, 0, 0, 0, 0, 0},	/* 9509 */
	{0, 0, 0, 0, 0, 0},	/* 9510 */
	{0, 0, 0, 0, 0, 0},	/* 9511 */
	{0, 0, 0, 0, 0, 0},	/* 9512 */
	{0, 0, 0, 0, 0, 0},	/* 9513 */
	{0, 0, 0, 0, 0, 0},	/* 9514 */
	{0, 0, 0, 0, 0, 0},	/* 9515 */
	{0, 0, 0, 0, 0, 0},	/* 9516 */
	{0, 0, 0, 0, 0, 0},	/* 9517 */
	{0, 0, 0, 0, 0, 0},	/* 9518 */
	{0, 0, 0, 0, 0, 0},	/* 9519 */
	{0, 0, 0, 0, 0, 0},	/* 9520 */
	{0, 0, 0, 0, 0, 0},	/* 9521 */
	{0, 0, 0, 0, 0, 0},	/* 9522 */
	{0, 0, 0, 0, 0, 0},	/* 9523 */
	{0, 0, 0, 0, 0, 0},	/* 9524 */
	{0, 0, 0, 0, 0, 0},	/* 9525 */
	{0, 0, 0, 0, 0, 0},	/* 9526 */
	{0, 0, 0, 0, 0, 0},	/* 9527 */
	{0, 0, 0, 0, 0, 0},	/* 9528 */
	{0, 0, 0, 0, 0, 0},	/* 9529 */
	{0, 0, 0, 0, 0, 0},	/* 9530 */
	{0, 0, 0, 0, 0, 0},	/* 9531 */
	{0, 0, 0, 0, 0, 0},	/* 9532 */
	{0, 0, 0, 0, 0, 0},	/* 9533 */
	{0, 0, 0, 0, 0, 0},	/* 9534 */
	{0, 0, 0, 0, 0, 0},	/* 9535 */
	{0, 0, 0, 0, 0, 0},	/* 9536 */
	{0, 0, 0, 0, 0, 0},	/* 9537 */
	{0, 0, 0, 0, 0, 0},	/* 9538 */
	{0, 0, 0, 0, 0, 0},	/* 9539 */
	{0, 0, 0, 0, 0, 0},	/* 9540 */
	{0, 0, 0, 0, 0, 0},	/* 9541 */
	{0, 0, 0, 0, 0, 0},	/* 9542 */
	{0, 0, 0, 0, 0, 0},	/* 9543 */
	{0, 0, 0, 0, 0, 0},	/* 9544 */
	{0, 0, 0, 0, 0, 0},	/* 9545 */
	{0, 0, 0, 0, 0, 0},	/* 9546 */
	{0, 0, 0, 0, 0, 0},	/* 9547 */
	{0, 0, 0, 0, 0, 0},	/* 9548 */
	{0, 0, 0, 0, 0, 0},	/* 9549 */
	{0, 0, 0, 0, 0, 0},	/* 9550 */
	{0, 0, 0, 0, 0, 0},	/* 9551 */
	{0, 0, 0, 0, 0, 0},	/* 9552 */
	{0, 0, 0, 0, 0, 0},	/* 9553 */
	{0, 0, 0, 0, 0, 0},	/* 9554 */
	{0, 0, 0, 0, 0, 0},	/* 9555 */
	{0, 0, 0, 0, 0, 0},	/* 9556 */
	{0, 0, 0, 0, 0, 0},	/* 9557 */
	{0, 0, 0, 0, 0, 0},	/* 9558 */
	{0, 0, 0, 0, 0, 0},	/* 9559 */
	{0, 0, 0, 0, 0, 0},	/* 9560 */
	{0, 0, 0, 0, 0, 0},	/* 9561 */
	{0, 0, 0, 0, 0, 0},	/* 9562 */
	{0, 0, 0, 0, 0, 0},	/* 9563 */
	{0, 0, 0, 0, 0, 0},	/* 9564 */
	{0, 0, 0, 0, 0, 0},	/* 9565 */
	{0, 0, 0, 0, 0, 0},	/* 9566 */
	{0, 0, 0, 0, 0, 0},	/* 9567 */
	{0, 0, 0, 0, 0, 0},	/* 9568 */
	{0, 0, 0, 0, 0, 0},	/* 9569 */
	{0, 0, 0, 0, 0, 0},	/* 9570 */
	{0, 0, 0, 0, 0, 0},	/* 9571 */
	{0, 0, 0, 0, 0, 0},	/* 9572 */
	{0, 0, 0, 0, 0, 0},	/* 9573 */
	{0, 0, 0, 0, 0, 0},	/* 9574 */
	{0, 0, 0, 0, 0, 0},	/* 9575 */
	{0, 0, 0, 0, 0, 0},	/* 9576 */
	{0, 0, 0, 0, 0, 0},	/* 9577 */
	{0, 0, 0, 0, 0, 0},	/* 9578 */
	{0, 0, 0, 0, 0, 0},	/* 9579 */
	{0, 0, 0, 0, 0, 0},	/* 9580 */
	{0, 0, 0, 0, 0, 0},	/* 9581 */
	{0, 0, 0, 0, 0, 0},	/* 9582 */
	{0, 0, 0, 0, 0, 0},	/* 9583 */
	{0, 0, 0, 0, 0, 0},	/* 9584 */
	{0, 0, 0, 0, 0, 0},	/* 9585 */
	{0, 0, 0, 0, 0, 0},	/* 9586 */
	{0, 0, 0, 0, 0, 0},	/* 9587 */
	{0, 0, 0, 0, 0, 0},	/* 9588 */
	{0, 0, 0, 0, 0, 0},	/* 9589 */
	{0, 0, 0, 0, 0, 0},	/* 9590 */
	{0, 0, 0, 0, 0, 0},	/* 9591 */
	{0, 0, 0, 0, 0, 0},	/* 9592 */
	{0, 0, 0, 0, 0, 0},	/* 9593 */
	{0, 0, 0, 0, 0, 0},	/* 9594 */
	{0, 0, 0, 0, 0, 0},	/* 9595 */
	{0, 0, 0, 0, 0, 0},	/* 9596 */
	{0, 0, 0, 0, 0, 0},	/* 9597 */
	{0, 0, 0, 0, 0, 0},	/* 9598 */
	{0, 0, 0, 0, 0, 0},	/* 9761 */
	{0, 0, 0, 0, 0, 0},	/* 9762 */
	{0, 0, 0, 0, 0, 0},	/* 9763 */
	{0, 0, 0, 0, 0, 0},	/* 9764 */
	{0, 0, 0, 0, 0, 0},	/* 9765 */
	{0, 0, 0, 0, 0, 0},	/* 9766 */
	{0, 0, 0, 0, 0, 0},	/* 9767 */
	{0, 0, 0, 0, 0, 0},	/* 9768 */
	{0, 0, 0, 0, 0, 0},	/* 9769 */
	{0, 0, 0, 0, 0, 0},	/* 9770 */
	{0, 0, 0, 0, 0, 0},	/* 9771 */
	{0, 0, 0, 0, 0, 0},	/* 9772 */
	{0, 0, 0, 0, 0, 0},	/* 9773 */
	{0, 0, 0, 0, 0, 0},	/* 9774 */
	{0, 0, 0, 0, 0, 0},	/* 9775 */
	{0, 0, 0, 0, 0, 0},	/* 9776 */
	{0, 0, 0, 0, 0, 0},	/* 9777 */
	{0, 0, 0, 0, 0, 0},	/* 9778 */
	{0, 0, 0, 0, 0, 0},	/* 9779 */
	{0, 0, 0, 0, 0, 0},	/* 9780 */
	{0, 0, 0, 0, 0, 0},	/* 9781 */
	{0, 0, 0, 0, 0, 0},	/* 9782 */
	{0, 0, 0, 0, 0, 0},	/* 9783 */
	{0, 0, 0, 0, 0, 0},	/* 9784 */
	{0, 0, 0, 0, 0, 0},	/* 9785 */
	{0, 0, 0, 0, 0, 0},	/* 9786 */
	{0, 0, 0, 0, 0, 0},	/* 9787 */
	{0, 0, 0, 0, 0, 0},	/* 9788 */
	{0, 0, 0, 0, 0, 0},	/* 9789 */
	{0, 0, 0, 0, 0, 0},	/* 9790 */
	{0, 0, 0, 0, 0, 0},	/* 9791 */
	{0, 0, 0, 0, 0, 0},	/* 9792 */
	{0, 0, 0, 0, 0, 0},	/* 9793 */
	{0, 0, 0, 0, 0, 0},	/* 9794 */
	{0, 0, 0, 0, 0, 0},	/* 9795 */
	{0, 0, 0, 0, 0, 0},	/* 9796 */
	{0, 0, 0, 0, 0, 0},	/* 9797 */
	{0, 0, 0, 0, 0, 0},	/* 9798 */
	{0, 0, 0, 0, 0, 0},	/* 9799 */
	{0, 0, 0, 0, 0, 0},	/* 9800 */
	{0, 0, 0, 0, 0, 0},	/* 9801 */
	{0, 0, 0, 0, 0, 0},	/* 9802 */
	{0, 0, 0, 0, 0, 0},	/* 9803 */
	{0, 0, 0, 0, 0, 0},	/* 9804 */
	{0, 0, 0, 0, 0, 0},	/* 9805 */
	{0, 0, 0, 0, 0, 0},	/* 9806 */
	{0, 0, 0, 0, 0, 0},	/* 9807 */
	{0, 0, 0, 0, 0, 0},	/* 9808 */
	{0, 0, 0, 0, 0, 0},	/* 9809 */
	{0, 0, 0, 0, 0, 0},	/* 9810 */
	{0, 0, 0, 0, 0, 0},	/* 9811 */
	{0, 0, 0, 0, 0, 0},	/* 9812 */
	{0, 0, 0, 0, 0, 0},	/* 9813 */
	{0, 0, 0, 0, 0, 0},	/* 9814 */
	{0, 0, 0, 0, 0, 0},	/* 9815 */
	{0, 0, 0, 0, 0, 0},	/* 9816 */
	{0, 0, 0, 0, 0, 0},	/* 9817 */
	{0, 0, 0, 0, 0, 0},	/* 9818 */
	{0, 0, 0, 0, 0, 0},	/* 9819 */
	{0, 0, 0, 0, 0, 0},	/* 9820 */
	{0, 0, 0, 0, 0, 0},	/* 9821 */
	{0, 0, 0, 0, 0, 0},	/* 9822 */
	{0, 0, 0, 0, 0, 0},	/* 9823 */
	{0, 0, 0, 0, 0, 0},	/* 9824 */
	{0, 0, 0, 0, 0, 0},	/* 9825 */
	{0, 0, 0, 0, 0, 0},	/* 9826 */
	{0, 0, 0, 0, 0, 0},	/* 9827 */
	{0, 0, 0, 0, 0, 0},	/* 9828 */
	{0, 0, 0, 0, 0, 0},	/* 9829 */
	{0, 0, 0, 0, 0, 0},	/* 9830 */
	{0, 0, 0, 0, 0, 0},	/* 9831 */
	{0, 0, 0, 0, 0, 0},	/* 9832 */
	{0, 0, 0, 0, 0, 0},	/* 9833 */
	{0, 0, 0, 0, 0, 0},	/* 9834 */
	{0, 0, 0, 0, 0, 0},	/* 9835 */
	{0, 0, 0, 0, 0, 0},	/* 9836 */
	{0, 0, 0, 0, 0, 0},	/* 9837 */
	{0, 0, 0, 0, 0, 0},	/* 9838 */
	{0, 0, 0, 0, 0, 0},	/* 9839 */
	{0, 0, 0, 0, 0, 0},	/* 9840 */
	{0, 0, 0, 0, 0, 0},	/* 9841 */
	{0, 0, 0, 0, 0, 0},	/* 9842 */
	{0, 0, 0, 0, 0, 0},	/* 9843 */
	{0, 0, 0, 0, 0, 0},	/* 9844 */
	{0, 0, 0, 0, 0, 0},	/* 9845 */
	{0, 0, 0, 0, 0, 0},	/* 9846 */
	{0, 0, 0, 0, 0, 0},	/* 9847 */
	{0, 0, 0, 0, 0, 0},	/* 9848 */
	{0, 0, 0, 0, 0, 0},	/* 9849 */
	{0, 0, 0, 0, 0, 0},	/* 9850 */
	{0, 0, 0, 0, 0, 0},	/* 9851 */
	{0, 0, 0, 0, 0, 0},	/* 9852 */
	{0, 0, 0, 0, 0, 0},	/* 9853 */
	{0, 0, 0, 0, 0, 0},	/* 9854 */
	{0, 0, 0, 0, 0, 0},	/* 10017 */
	{0, 0, 0, 0, 0, 0},	/* 10018 */
	{0, 0, 0, 0, 0, 0},	/* 10019 */
	{0, 0, 0, 0, 0, 0},	/* 10020 */
	{0, 0, 0, 0, 0, 0},	/* 10021 */
	{0, 0, 0, 0, 0, 0},	/* 10022 */
	{0, 0, 0, 0, 0, 0},	/* 10023 */
	{0, 0, 0, 0, 0, 0},	/* 10024 */
	{0, 0, 0, 0, 0, 0},	/* 10025 */
	{0, 0, 0, 0, 0, 0},	/* 10026 */
	{0, 0, 0, 0, 0, 0},	/* 10027 */
	{0, 0, 0, 0, 0, 0},	/* 10028 */
	{0, 0, 0, 0, 0, 0},	/* 10029 */
	{0, 0, 0, 0, 0, 0},	/* 10030 */
	{0, 0, 0, 0, 0, 0},	/* 10031 */
	{0, 0, 0, 0, 0, 0},	/* 10032 */
	{0, 0, 0, 0, 0, 0},	/* 10033 */
	{0, 0, 0, 0, 0, 0},	/* 10034 */
	{0, 0, 0, 0, 0, 0},	/* 10035 */
	{0, 0, 0, 0, 0, 0},	/* 10036 */
	{0, 0, 0, 0, 0, 0},	/* 10037 */
	{0, 0, 0, 0, 0, 0},	/* 10038 */
	{0, 0, 0, 0, 0, 0},	/* 10039 */
	{0, 0, 0, 0, 0, 0},	/* 10040 */
	{0, 0, 0, 0, 0, 0},	/* 10041 */
	{0, 0, 0, 0, 0, 0},	/* 10042 */
	{0, 0, 0, 0, 0, 0},	/* 10043 */
	{0, 0, 0, 0, 0, 0},	/* 10044 */
	{0, 0, 0, 0, 0, 0},	/* 10045 */
	{0, 0, 0, 0, 0, 0},	/* 10046 */
	{0, 0, 0, 0, 0, 0},	/* 10047 */
	{0, 0, 0, 0, 0, 0},	/* 10048 */
	{0, 0, 0, 0, 0, 0},	/* 10049 */
	{0, 0, 0, 0, 0, 0},	/* 10050 */
	{0, 0, 0, 0, 0, 0},	/* 10051 */
	{0, 0, 0, 0, 0, 0},	/* 10052 */
	{0, 0, 0, 0, 0, 0},	/* 10053 */
	{0, 0, 0, 0, 0, 0},	/* 10054 */
	{0, 0, 0, 0, 0, 0},	/* 10055 */
	{0, 0, 0, 0, 0, 0},	/* 10056 */
	{0, 0, 0, 0, 0, 0},	/* 10057 */
	{0, 0, 0, 0, 0, 0},	/* 10058 */
	{0, 0, 0, 0, 0, 0},	/* 10059 */
	{0, 0, 0, 0, 0, 0},	/* 10060 */
	{0, 0, 0, 0, 0, 0},	/* 10061 */
	{0, 0, 0, 0, 0, 0},	/* 10062 */
	{0, 0, 0, 0, 0, 0},	/* 10063 */
	{0, 0, 0, 0, 0, 0},	/* 10064 */
	{0, 0, 0, 0, 0, 0},	/* 10065 */
	{0, 0, 0, 0, 0, 0},	/* 10066 */
	{0, 0, 0, 0, 0, 0},	/* 10067 */
	{0, 0, 0, 0, 0, 0},	/* 10068 */
	{0, 0, 0, 0, 0, 0},	/* 10069 */
	{0, 0, 0, 0, 0, 0},	/* 10070 */
	{0, 0, 0, 0, 0, 0},	/* 10071 */
	{0, 0, 0, 0, 0, 0},	/* 10072 */
	{0, 0, 0, 0, 0, 0},	/* 10073 */
	{0, 0, 0, 0, 0, 0},	/* 10074 */
	{0, 0, 0, 0, 0, 0},	/* 10075 */
	{0, 0, 0, 0, 0, 0},	/* 10076 */
	{0, 0, 0, 0, 0, 0},	/* 10077 */
	{0, 0, 0, 0, 0, 0},	/* 10078 */
	{0, 0, 0, 0, 0, 0},	/* 10079 */
	{0, 0, 0, 0, 0, 0},	/* 10080 */
	{0, 0, 0, 0, 0, 0},	/* 10081 */
	{0, 0, 0, 0, 0, 0},	/* 10082 */
	{0, 0, 0, 0, 0, 0},	/* 10083 */
	{0, 0, 0, 0, 0, 0},	/* 10084 */
	{0, 0, 0, 0, 0, 0},	/* 10085 */
	{0, 0, 0, 0, 0, 0},	/* 10086 */
	{0, 0, 0, 0, 0, 0},	/* 10087 */
	{0, 0, 0, 0, 0, 0},	/* 10088 */
	{0, 0, 0, 0, 0, 0},	/* 10089 */
	{0, 0, 0, 0, 0, 0},	/* 10090 */
	{0, 0, 0, 0, 0, 0},	/* 10091 */
	{0, 0, 0, 0, 0, 0},	/* 10092 */
	{0, 0, 0, 0, 0, 0},	/* 10093 */
	{0, 0, 0, 0, 0, 0},	/* 10094 */
	{0, 0, 0, 0, 0, 0},	/* 10095 */
	{0, 0, 0, 0, 0, 0},	/* 10096 */
	{0, 0, 0, 0, 0, 0},	/* 10097 */
	{0, 0, 0, 0, 0, 0},	/* 10098 */
	{0, 0, 0, 0, 0, 0},	/* 10099 */
	{0, 0, 0, 0, 0, 0},	/* 10100 */
	{0, 0, 0, 0, 0, 0},	/* 10101 */
	{0, 0, 0, 0, 0, 0},	/* 10102 */
	{0, 0, 0, 0, 0, 0},	/* 10103 */
	{0, 0, 0, 0, 0, 0},	/* 10104 */
	{0, 0, 0, 0, 0, 0},	/* 10105 */
	{0, 0, 0, 0, 0, 0},	/* 10106 */
	{0, 0, 0, 0, 0, 0},	/* 10107 */
	{0, 0, 0, 0, 0, 0},	/* 10108 */
	{0, 0, 0, 0, 0, 0},	/* 10109 */
	{0, 0, 0, 0, 0, 0},	/* 10110 */
	{0, 0, 0, 0, 0, 0},	/* 10273 */
	{0, 0, 0, 0, 0, 0},	/* 10274 */
	{0, 0, 0, 0, 0, 0},	/* 10275 */
	{0, 0, 0, 0, 0, 0},	/* 10276 */
	{0, 0, 0, 0, 0, 0},	/* 10277 */
	{0, 0, 0, 0, 0, 0},	/* 10278 */
	{0, 0, 0, 0, 0, 0},	/* 10279 */
	{0, 0, 0, 0, 0, 0},	/* 10280 */
	{0, 0, 0, 0, 0, 0},	/* 10281 */
	{0, 0, 0, 0, 0, 0},	/* 10282 */
	{0, 0, 0, 0, 0, 0},	/* 10283 */
	{0, 0, 0, 0, 0, 0},	/* 10284 */
	{0, 0, 0, 0, 0, 0},	/* 10285 */
	{0, 0, 0, 0, 0, 0},	/* 10286 */
	{0, 0, 0, 0, 0, 0},	/* 10287 */
	{0, 0, 0, 0, 0, 0},	/* 10288 */
	{0, 0, 0, 0, 0, 0},	/* 10289 */
	{0, 0, 0, 0, 0, 0},	/* 10290 */
	{0, 0, 0, 0, 0, 0},	/* 10291 */
	{0, 0, 0, 0, 0, 0},	/* 10292 */
	{0, 0, 0, 0, 0, 0},	/* 10293 */
	{0, 0, 0, 0, 0, 0},	/* 10294 */
	{0, 0, 0, 0, 0, 0},	/* 10295 */
	{0, 0, 0, 0, 0, 0},	/* 10296 */
	{0, 0, 0, 0, 0, 0},	/* 10297 */
	{0, 0, 0, 0, 0, 0},	/* 10298 */
	{0, 0, 0, 0, 0, 0},	/* 10299 */
	{0, 0, 0, 0, 0, 0},	/* 10300 */
	{0, 0, 0, 0, 0, 0},	/* 10301 */
	{0, 0, 0, 0, 0, 0},	/* 10302 */
	{0, 0, 0, 0, 0, 0},	/* 10303 */
	{0, 0, 0, 0, 0, 0},	/* 10304 */
	{0, 0, 0, 0, 0, 0},	/* 10305 */
	{0, 0, 0, 0, 0, 0},	/* 10306 */
	{0, 0, 0, 0, 0, 0},	/* 10307 */
	{0, 0, 0, 0, 0, 0},	/* 10308 */
	{0, 0, 0, 0, 0, 0},	/* 10309 */
	{0, 0, 0, 0, 0, 0},	/* 10310 */
	{0, 0, 0, 0, 0, 0},	/* 10311 */
	{0, 0, 0, 0, 0, 0},	/* 10312 */
	{0, 0, 0, 0, 0, 0},	/* 10313 */
	{0, 0, 0, 0, 0, 0},	/* 10314 */
	{0, 0, 0, 0, 0, 0},	/* 10315 */
	{0, 0, 0, 0, 0, 0},	/* 10316 */
	{0, 0, 0, 0, 0, 0},	/* 10317 */
	{0, 0, 0, 0, 0, 0},	/* 10318 */
	{0, 0, 0, 0, 0, 0},	/* 10319 */
	{0, 0, 0, 0, 0, 0},	/* 10320 */
	{0, 0, 0, 0, 0, 0},	/* 10321 */
	{0, 0, 0, 0, 0, 0},	/* 10322 */
	{0, 0, 0, 0, 0, 0},	/* 10323 */
	{0, 0, 0, 0, 0, 0},	/* 10324 */
	{0, 0, 0, 0, 0, 0},	/* 10325 */
	{0, 0, 0, 0, 0, 0},	/* 10326 */
	{0, 0, 0, 0, 0, 0},	/* 10327 */
	{0, 0, 0, 0, 0, 0},	/* 10328 */
	{0, 0, 0, 0, 0, 0},	/* 10329 */
	{0, 0, 0, 0, 0, 0},	/* 10330 */
	{0, 0, 0, 0, 0, 0},	/* 10331 */
	{0, 0, 0, 0, 0, 0},	/* 10332 */
	{0, 0, 0, 0, 0, 0},	/* 10333 */
	{0, 0, 0, 0, 0, 0},	/* 10334 */
	{0, 0, 0, 0, 0, 0},	/* 10335 */
	{0, 0, 0, 0, 0, 0},	/* 10336 */
	{0, 0, 0, 0, 0, 0},	/* 10337 */
	{0, 0, 0, 0, 0, 0},	/* 10338 */
	{0, 0, 0, 0, 0, 0},	/* 10339 */
	{0, 0, 0, 0, 0, 0},	/* 10340 */
	{0, 0, 0, 0, 0, 0},	/* 10341 */
	{0, 0, 0, 0, 0, 0},	/* 10342 */
	{0, 0, 0, 0, 0, 0},	/* 10343 */
	{0, 0, 0, 0, 0, 0},	/* 10344 */
	{0, 0, 0, 0, 0, 0},	/* 10345 */
	{0, 0, 0, 0, 0, 0},	/* 10346 */
	{0, 0, 0, 0, 0, 0},	/* 10347 */
	{0, 0, 0, 0, 0, 0},	/* 10348 */
	{0, 0, 0, 0, 0, 0},	/* 10349 */
	{0, 0, 0, 0, 0, 0},	/* 10350 */
	{0, 0, 0, 0, 0, 0},	/* 10351 */
	{0, 0, 0, 0, 0, 0},	/* 10352 */
	{0, 0, 0, 0, 0, 0},	/* 10353 */
	{0, 0, 0, 0, 0, 0},	/* 10354 */
	{0, 0, 0, 0, 0, 0},	/* 10355 */
	{0, 0, 0, 0, 0, 0},	/* 10356 */
	{0, 0, 0, 0, 0, 0},	/* 10357 */
	{0, 0, 0, 0, 0, 0},	/* 10358 */
	{0, 0, 0, 0, 0, 0},	/* 10359 */
	{0, 0, 0, 0, 0, 0},	/* 10360 */
	{0, 0, 0, 0, 0, 0},	/* 10361 */
	{0, 0, 0, 0, 0, 0},	/* 10362 */
	{0, 0, 0, 0, 0, 0},	/* 10363 */
	{0, 0, 0, 0, 0, 0},	/* 10364 */
	{0, 0, 0, 0, 0, 0},	/* 10365 */
	{0, 0, 0, 0, 0, 0},	/* 10366 */
	{0, 0, 0, 0, 0, 0},	/* 10529 */
	{0, 0, 0, 0, 0, 0},	/* 10530 */
	{0, 0, 0, 0, 0, 0},	/* 10531 */
	{0, 0, 0, 0, 0, 0},	/* 10532 */
	{0, 0, 0, 0, 0, 0},	/* 10533 */
	{0, 0, 0, 0, 0, 0},	/* 10534 */
	{0, 0, 0, 0, 0, 0},	/* 10535 */
	{0, 0, 0, 0, 0, 0},	/* 10536 */
	{0, 0, 0, 0, 0, 0},	/* 10537 */
	{0, 0, 0, 0, 0, 0},	/* 10538 */
	{0, 0, 0, 0, 0, 0},	/* 10539 */
	{0, 0, 0, 0, 0, 0},	/* 10540 */
	{0, 0, 0, 0, 0, 0},	/* 10541 */
	{0, 0, 0, 0, 0, 0},	/* 10542 */
	{0, 0, 0, 0, 0, 0},	/* 10543 */
	{0, 0, 0, 0, 0, 0},	/* 10544 */
	{0, 0, 0, 0, 0, 0},	/* 10545 */
	{0, 0, 0, 0, 0, 0},	/* 10546 */
	{0, 0, 0, 0, 0, 0},	/* 10547 */
	{0, 0, 0, 0, 0, 0},	/* 10548 */
	{0, 0, 0, 0, 0, 0},	/* 10549 */
	{0, 0, 0, 0, 0, 0},	/* 10550 */
	{0, 0, 0, 0, 0, 0},	/* 10551 */
	{0, 0, 0, 0, 0, 0},	/* 10552 */
	{0, 0, 0, 0, 0, 0},	/* 10553 */
	{0, 0, 0, 0, 0, 0},	/* 10554 */
	{0, 0, 0, 0, 0, 0},	/* 10555 */
	{0, 0, 0, 0, 0, 0},	/* 10556 */
	{0, 0, 0, 0, 0, 0},	/* 10557 */
	{0, 0, 0, 0, 0, 0},	/* 10558 */
	{0, 0, 0, 0, 0, 0},	/* 10559 */
	{0, 0, 0, 0, 0, 0},	/* 10560 */
	{0, 0, 0, 0, 0, 0},	/* 10561 */
	{0, 0, 0, 0, 0, 0},	/* 10562 */
	{0, 0, 0, 0, 0, 0},	/* 10563 */
	{0, 0, 0, 0, 0, 0},	/* 10564 */
	{0, 0, 0, 0, 0, 0},	/* 10565 */
	{0, 0, 0, 0, 0, 0},	/* 10566 */
	{0, 0, 0, 0, 0, 0},	/* 10567 */
	{0, 0, 0, 0, 0, 0},	/* 10568 */
	{0, 0, 0, 0, 0, 0},	/* 10569 */
	{0, 0, 0, 0, 0, 0},	/* 10570 */
	{0, 0, 0, 0, 0, 0},	/* 10571 */
	{0, 0, 0, 0, 0, 0},	/* 10572 */
	{0, 0, 0, 0, 0, 0},	/* 10573 */
	{0, 0, 0, 0, 0, 0},	/* 10574 */
	{0, 0, 0, 0, 0, 0},	/* 10575 */
	{0, 0, 0, 0, 0, 0},	/* 10576 */
	{0, 0, 0, 0, 0, 0},	/* 10577 */
	{0, 0, 0, 0, 0, 0},	/* 10578 */
	{0, 0, 0, 0, 0, 0},	/* 10579 */
	{0, 0, 0, 0, 0, 0},	/* 10580 */
	{0, 0, 0, 0, 0, 0},	/* 10581 */
	{0, 0, 0, 0, 0, 0},	/* 10582 */
	{0, 0, 0, 0, 0, 0},	/* 10583 */
	{0, 0, 0, 0, 0, 0},	/* 10584 */
	{0, 0, 0, 0, 0, 0},	/* 10585 */
	{0, 0, 0, 0, 0, 0},	/* 10586 */
	{0, 0, 0, 0, 0, 0},	/* 10587 */
	{0, 0, 0, 0, 0, 0},	/* 10588 */
	{0, 0, 0, 0, 0, 0},	/* 10589 */
	{0, 0, 0, 0, 0, 0},	/* 10590 */
	{0, 0, 0, 0, 0, 0},	/* 10591 */
	{0, 0, 0, 0, 0, 0},	/* 10592 */
	{0, 0, 0, 0, 0, 0},	/* 10593 */
	{0, 0, 0, 0, 0, 0},	/* 10594 */
	{0, 0, 0, 0, 0, 0},	/* 10595 */
	{0, 0, 0, 0, 0, 0},	/* 10596 */
	{0, 0, 0, 0, 0, 0},	/* 10597 */
	{0, 0, 0, 0, 0, 0},	/* 10598 */
	{0, 0, 0, 0, 0, 0},	/* 10599 */
	{0, 0, 0, 0, 0, 0},	/* 10600 */
	{0, 0, 0, 0, 0, 0},	/* 10601 */
	{0, 0, 0, 0, 0, 0},	/* 10602 */
	{0, 0, 0, 0, 0, 0},	/* 10603 */
	{0, 0, 0, 0, 0, 0},	/* 10604 */
	{0, 0, 0, 0, 0, 0},	/* 10605 */
	{0, 0, 0, 0, 0, 0},	/* 10606 */
	{0, 0, 0, 0, 0, 0},	/* 10607 */
	{0, 0, 0, 0, 0, 0},	/* 10608 */
	{0, 0, 0, 0, 0, 0},	/* 10609 */
	{0, 0, 0, 0, 0, 0},	/* 10610 */
	{0, 0, 0, 0, 0, 0},	/* 10611 */
	{0, 0, 0, 0, 0, 0},	/* 10612 */
	{0, 0, 0, 0, 0, 0},	/* 10613 */
	{0, 0, 0, 0, 0, 0},	/* 10614 */
	{0, 0, 0, 0, 0, 0},	/* 10615 */
	{0, 0, 0, 0, 0, 0},	/* 10616 */
	{0, 0, 0, 0, 0, 0},	/* 10617 */
	{0, 0, 0, 0, 0, 0},	/* 10618 */
	{0, 0, 0, 0, 0, 0},	/* 10619 */
	{0, 0, 0, 0, 0, 0},	/* 10620 */
	{0, 0, 0, 0, 0, 0},	/* 10621 */
	{0, 0, 0, 0, 0, 0},	/* 10622 */
	{0, 0, 0, 0, 0, 0},	/* 10785 */
	{0, 0, 0, 0, 0, 0},	/* 10786 */
	{0, 0, 0, 0, 0, 0},	/* 10787 */
	{0, 0, 0, 0, 0, 0},	/* 10788 */
	{0, 0, 0, 0, 0, 0},	/* 10789 */
	{0, 0, 0, 0, 0, 0},	/* 10790 */
	{0, 0, 0, 0, 0, 0},	/* 10791 */
	{0, 0, 0, 0, 0, 0},	/* 10792 */
	{0, 0, 0, 0, 0, 0},	/* 10793 */
	{0, 0, 0, 0, 0, 0},	/* 10794 */
	{0, 0, 0, 0, 0, 0},	/* 10795 */
	{0, 0, 0, 0, 0, 0},	/* 10796 */
	{0, 0, 0, 0, 0, 0},	/* 10797 */
	{0, 0, 0, 0, 0, 0},	/* 10798 */
	{0, 0, 0, 0, 0, 0},	/* 10799 */
	{0, 0, 0, 0, 0, 0},	/* 10800 */
	{0, 0, 0, 0, 0, 0},	/* 10801 */
	{0, 0, 0, 0, 0, 0},	/* 10802 */
	{0, 0, 0, 0, 0, 0},	/* 10803 */
	{0, 0, 0, 0, 0, 0},	/* 10804 */
	{0, 0, 0, 0, 0, 0},	/* 10805 */
	{0, 0, 0, 0, 0, 0},	/* 10806 */
	{0, 0, 0, 0, 0, 0},	/* 10807 */
	{0, 0, 0, 0, 0, 0},	/* 10808 */
	{0, 0, 0, 0, 0, 0},	/* 10809 */
	{0, 0, 0, 0, 0, 0},	/* 10810 */
	{0, 0, 0, 0, 0, 0},	/* 10811 */
	{0, 0, 0, 0, 0, 0},	/* 10812 */
	{0, 0, 0, 0, 0, 0},	/* 10813 */
	{0, 0, 0, 0, 0, 0},	/* 10814 */
	{0, 0, 0, 0, 0, 0},	/* 10815 */
	{0, 0, 0, 0, 0, 0},	/* 10816 */
	{0, 0, 0, 0, 0, 0},	/* 10817 */
	{0, 0, 0, 0, 0, 0},	/* 10818 */
	{0, 0, 0, 0, 0, 0},	/* 10819 */
	{0, 0, 0, 0, 0, 0},	/* 10820 */
	{0, 0, 0, 0, 0, 0},	/* 10821 */
	{0, 0, 0, 0, 0, 0},	/* 10822 */
	{0, 0, 0, 0, 0, 0},	/* 10823 */
	{0, 0, 0, 0, 0, 0},	/* 10824 */
	{0, 0, 0, 0, 0, 0},	/* 10825 */
	{0, 0, 0, 0, 0, 0},	/* 10826 */
	{0, 0, 0, 0, 0, 0},	/* 10827 */
	{0, 0, 0, 0, 0, 0},	/* 10828 */
	{0, 0, 0, 0, 0, 0},	/* 10829 */
	{0, 0, 0, 0, 0, 0},	/* 10830 */
	{0, 0, 0, 0, 0, 0},	/* 10831 */
	{0, 0, 0, 0, 0, 0},	/* 10832 */
	{0, 0, 0, 0, 0, 0},	/* 10833 */
	{0, 0, 0, 0, 0, 0},	/* 10834 */
	{0, 0, 0, 0, 0, 0},	/* 10835 */
	{0, 0, 0, 0, 0, 0},	/* 10836 */
	{0, 0, 0, 0, 0, 0},	/* 10837 */
	{0, 0, 0, 0, 0, 0},	/* 10838 */
	{0, 0, 0, 0, 0, 0},	/* 10839 */
	{0, 0, 0, 0, 0, 0},	/* 10840 */
	{0, 0, 0, 0, 0, 0},	/* 10841 */
	{0, 0, 0, 0, 0, 0},	/* 10842 */
	{0, 0, 0, 0, 0, 0},	/* 10843 */
	{0, 0, 0, 0, 0, 0},	/* 10844 */
	{0, 0, 0, 0, 0, 0},	/* 10845 */
	{0, 0, 0, 0, 0, 0},	/* 10846 */
	{0, 0, 0, 0, 0, 0},	/* 10847 */
	{0, 0, 0, 0, 0, 0},	/* 10848 */
	{0, 0, 0, 0, 0, 0},	/* 10849 */
	{0, 0, 0, 0, 0, 0},	/* 10850 */
	{0, 0, 0, 0, 0, 0},	/* 10851 */
	{0, 0, 0, 0, 0, 0},	/* 10852 */
	{0, 0, 0, 0, 0, 0},	/* 10853 */
	{0, 0, 0, 0, 0, 0},	/* 10854 */
	{0, 0, 0, 0, 0, 0},	/* 10855 */
	{0, 0, 0, 0, 0, 0},	/* 10856 */
	{0, 0, 0, 0, 0, 0},	/* 10857 */
	{0, 0, 0, 0, 0, 0},	/* 10858 */
	{0, 0, 0, 0, 0, 0},	/* 10859 */
	{0, 0, 0, 0, 0, 0},	/* 10860 */
	{0, 0, 0, 0, 0, 0},	/* 10861 */
	{0, 0, 0, 0, 0, 0},	/* 10862 */
	{0, 0, 0, 0, 0, 0},	/* 10863 */
	{0, 0, 0, 0, 0, 0},	/* 10864 */
	{0, 0, 0, 0, 0, 0},	/* 10865 */
	{0, 0, 0, 0, 0, 0},	/* 10866 */
	{0, 0, 0, 0, 0, 0},	/* 10867 */
	{0, 0, 0, 0, 0, 0},	/* 10868 */
	{0, 0, 0, 0, 0, 0},	/* 10869 */
	{0, 0, 0, 0, 0, 0},	/* 10870 */
	{0, 0, 0, 0, 0, 0},	/* 10871 */
	{0, 0, 0, 0, 0, 0},	/* 10872 */
	{0, 0, 0, 0, 0, 0},	/* 10873 */
	{0, 0, 0, 0, 0, 0},	/* 10874 */
	{0, 0, 0, 0, 0, 0},	/* 10875 */
	{0, 0, 0, 0, 0, 0},	/* 10876 */
	{0, 0, 0, 0, 0, 0},	/* 10877 */
	{0, 0, 0, 0, 0, 0},	/* 10878 */
	{0, 0, 0, 0, 0, 0},	/* 11041 */
	{0, 0, 0, 0, 0, 0},	/* 11042 */
	{0, 0, 0, 0, 0, 0},	/* 11043 */
	{0, 0, 0, 0, 0, 0},	/* 11044 */
	{0, 0, 0, 0, 0, 0},	/* 11045 */
	{0, 0, 0, 0, 0, 0},	/* 11046 */
	{0, 0, 0, 0, 0, 0},	/* 11047 */
	{0, 0, 0, 0, 0, 0},	/* 11048 */
	{0, 0, 0, 0, 0, 0},	/* 11049 */
	{0, 0, 0, 0, 0, 0},	/* 11050 */
	{0, 0, 0, 0, 0, 0},	/* 11051 */
	{0, 0, 0, 0, 0, 0},	/* 11052 */
	{0, 0, 0, 0, 0, 0},	/* 11053 */
	{0, 0, 0, 0, 0, 0},	/* 11054 */
	{0, 0, 0, 0, 0, 0},	/* 11055 */
	{0, 0, 0, 0, 0, 0},	/* 11056 */
	{0, 0, 0, 0, 0, 0},	/* 11057 */
	{0, 0, 0, 0, 0, 0},	/* 11058 */
	{0, 0, 0, 0, 0, 0},	/* 11059 */
	{0, 0, 0, 0, 0, 0},	/* 11060 */
	{0, 0, 0, 0, 0, 0},	/* 11061 */
	{0, 0, 0, 0, 0, 0},	/* 11062 */
	{0, 0, 0, 0, 0, 0},	/* 11063 */
	{0, 0, 0, 0, 0, 0},	/* 11064 */
	{0, 0, 0, 0, 0, 0},	/* 11065 */
	{0, 0, 0, 0, 0, 0},	/* 11066 */
	{0, 0, 0, 0, 0, 0},	/* 11067 */
	{0, 0, 0, 0, 0, 0},	/* 11068 */
	{0, 0, 0, 0, 0, 0},	/* 11069 */
	{0, 0, 0, 0, 0, 0},	/* 11070 */
	{0, 0, 0, 0, 0, 0},	/* 11071 */
	{0, 0, 0, 0, 0, 0},	/* 11072 */
	{0, 0, 0, 0, 0, 0},	/* 11073 */
	{0, 0, 0, 0, 0, 0},	/* 11074 */
	{0, 0, 0, 0, 0, 0},	/* 11075 */
	{0, 0, 0, 0, 0, 0},	/* 11076 */
	{0, 0, 0, 0, 0, 0},	/* 11077 */
	{0, 0, 0, 0, 0, 0},	/* 11078 */
	{0, 0, 0, 0, 0, 0},	/* 11079 */
	{0, 0, 0, 0, 0, 0},	/* 11080 */
	{0, 0, 0, 0, 0, 0},	/* 11081 */
	{0, 0, 0, 0, 0, 0},	/* 11082 */
	{0, 0, 0, 0, 0, 0},	/* 11083 */
	{0, 0, 0, 0, 0, 0},	/* 11084 */
	{0, 0, 0, 0, 0, 0},	/* 11085 */
	{0, 0, 0, 0, 0, 0},	/* 11086 */
	{0, 0, 0, 0, 0, 0},	/* 11087 */
	{0, 0, 0, 0, 0, 0},	/* 11088 */
	{0, 0, 0, 0, 0, 0},	/* 11089 */
	{0, 0, 0, 0, 0, 0},	/* 11090 */
	{0, 0, 0, 0, 0, 0},	/* 11091 */
	{0, 0, 0, 0, 0, 0},	/* 11092 */
	{0, 0, 0, 0, 0, 0},	/* 11093 */
	{0, 0, 0, 0, 0, 0},	/* 11094 */
	{0, 0, 0, 0, 0, 0},	/* 11095 */
	{0, 0, 0, 0, 0, 0},	/* 11096 */
	{0, 0, 0, 0, 0, 0},	/* 11097 */
	{0, 0, 0, 0, 0, 0},	/* 11098 */
	{0, 0, 0, 0, 0, 0},	/* 11099 */
	{0, 0, 0, 0, 0, 0},	/* 11100 */
	{0, 0, 0, 0, 0, 0},	/* 11101 */
	{0, 0, 0, 0, 0, 0},	/* 11102 */
	{0, 0, 0, 0, 0, 0},	/* 11103 */
	{0, 0, 0, 0, 0, 0},	/* 11104 */
	{0, 0, 0, 0, 0, 0},	/* 11105 */
	{0, 0, 0, 0, 0, 0},	/* 11106 */
	{0, 0, 0, 0, 0, 0},	/* 11107 */
	{0, 0, 0, 0, 0, 0},	/* 11108 */
	{0, 0, 0, 0, 0, 0},	/* 11109 */
	{0, 0, 0, 0, 0, 0},	/* 11110 */
	{0, 0, 0, 0, 0, 0},	/* 11111 */
	{0, 0, 0, 0, 0, 0},	/* 11112 */
	{0, 0, 0, 0, 0, 0},	/* 11113 */
	{0, 0, 0, 0, 0, 0},	/* 11114 */
	{0, 0, 0, 0, 0, 0},	/* 11115 */
	{0, 0, 0, 0, 0, 0},	/* 11116 */
	{0, 0, 0, 0, 0, 0},	/* 11117 */
	{0, 0, 0, 0, 0, 0},	/* 11118 */
	{0, 0, 0, 0, 0, 0},	/* 11119 */
	{0, 0, 0, 0, 0, 0},	/* 11120 */
	{0, 0, 0, 0, 0, 0},	/* 11121 */
	{0, 0, 0, 0, 0, 0},	/* 11122 */
	{0, 0, 0, 0, 0, 0},	/* 11123 */
	{0, 0, 0, 0, 0, 0},	/* 11124 */
	{0, 0, 0, 0, 0, 0},	/* 11125 */
	{0, 0, 0, 0, 0, 0},	/* 11126 */
	{0, 0, 0, 0, 0, 0},	/* 11127 */
	{0, 0, 0, 0, 0, 0},	/* 11128 */
	{0, 0, 0, 0, 0, 0},	/* 11129 */
	{0, 0, 0, 0, 0, 0},	/* 11130 */
	{0, 0, 0, 0, 0, 0},	/* 11131 */
	{0, 0, 0, 0, 0, 0},	/* 11132 */
	{0, 0, 0, 0, 0, 0},	/* 11133 */
	{0, 0, 0, 0, 0, 0},	/* 11134 */
	{0, 0, 0, 0, 0, 0},	/* 11297 */
	{0, 0, 0, 0, 0, 0},	/* 11298 */
	{0, 0, 0, 0, 0, 0},	/* 11299 */
	{0, 0, 0, 0, 0, 0},	/* 11300 */
	{0, 0, 0, 0, 0, 0},	/* 11301 */
	{0, 0, 0, 0, 0, 0},	/* 11302 */
	{0, 0, 0, 0, 0, 0},	/* 11303 */
	{0, 0, 0, 0, 0, 0},	/* 11304 */
	{0, 0, 0, 0, 0, 0},	/* 11305 */
	{0, 0, 0, 0, 0, 0},	/* 11306 */
	{0, 0, 0, 0, 0, 0},	/* 11307 */
	{0, 0, 0, 0, 0, 0},	/* 11308 */
	{0, 0, 0, 0, 0, 0},	/* 11309 */
	{0, 0, 0, 0, 0, 0},	/* 11310 */
	{0, 0, 0, 0, 0, 0},	/* 11311 */
	{0, 0, 0, 0, 0, 0},	/* 11312 */
	{0, 0, 0, 0, 0, 0},	/* 11313 */
	{0, 0, 0, 0, 0, 0},	/* 11314 */
	{0, 0, 0, 0, 0, 0},	/* 11315 */
	{0, 0, 0, 0, 0, 0},	/* 11316 */
	{0, 0, 0, 0, 0, 0},	/* 11317 */
	{0, 0, 0, 0, 0, 0},	/* 11318 */
	{0, 0, 0, 0, 0, 0},	/* 11319 */
	{0, 0, 0, 0, 0, 0},	/* 11320 */
	{0, 0, 0, 0, 0, 0},	/* 11321 */
	{0, 0, 0, 0, 0, 0},	/* 11322 */
	{0, 0, 0, 0, 0, 0},	/* 11323 */
	{0, 0, 0, 0, 0, 0},	/* 11324 */
	{0, 0, 0, 0, 0, 0},	/* 11325 */
	{0, 0, 0, 0, 0, 0},	/* 11326 */
	{0, 0, 0, 0, 0, 0},	/* 11327 */
	{0, 0, 0, 0, 0, 0},	/* 11328 */
	{0, 0, 0, 0, 0, 0},	/* 11329 */
	{0, 0, 0, 0, 0, 0},	/* 11330 */
	{0, 0, 0, 0, 0, 0},	/* 11331 */
	{0, 0, 0, 0, 0, 0},	/* 11332 */
	{0, 0, 0, 0, 0, 0},	/* 11333 */
	{0, 0, 0, 0, 0, 0},	/* 11334 */
	{0, 0, 0, 0, 0, 0},	/* 11335 */
	{0, 0, 0, 0, 0, 0},	/* 11336 */
	{0, 0, 0, 0, 0, 0},	/* 11337 */
	{0, 0, 0, 0, 0, 0},	/* 11338 */
	{0, 0, 0, 0, 0, 0},	/* 11339 */
	{0, 0, 0, 0, 0, 0},	/* 11340 */
	{0, 0, 0, 0, 0, 0},	/* 11341 */
	{0, 0, 0, 0, 0, 0},	/* 11342 */
	{0, 0, 0, 0, 0, 0},	/* 11343 */
	{0, 0, 0, 0, 0, 0},	/* 11344 */
	{0, 0, 0, 0, 0, 0},	/* 11345 */
	{0, 0, 0, 0, 0, 0},	/* 11346 */
	{0, 0, 0, 0, 0, 0},	/* 11347 */
	{0, 0, 0, 0, 0, 0},	/* 11348 */
	{0, 0, 0, 0, 0, 0},	/* 11349 */
	{0, 0, 0, 0, 0, 0},	/* 11350 */
	{0, 0, 0, 0, 0, 0},	/* 11351 */
	{0, 0, 0, 0, 0, 0},	/* 11352 */
	{0, 0, 0, 0, 0, 0},	/* 11353 */
	{0, 0, 0, 0, 0, 0},	/* 11354 */
	{0, 0, 0, 0, 0, 0},	/* 11355 */
	{0, 0, 0, 0, 0, 0},	/* 11356 */
	{0, 0, 0, 0, 0, 0},	/* 11357 */
	{0, 0, 0, 0, 0, 0},	/* 11358 */
	{0, 0, 0, 0, 0, 0},	/* 11359 */
	{0, 0, 0, 0, 0, 0},	/* 11360 */
	{0, 0, 0, 0, 0, 0},	/* 11361 */
	{0, 0, 0, 0, 0, 0},	/* 11362 */
	{0, 0, 0, 0, 0, 0},	/* 11363 */
	{0, 0, 0, 0, 0, 0},	/* 11364 */
	{0, 0, 0, 0, 0, 0},	/* 11365 */
	{0, 0, 0, 0, 0, 0},	/* 11366 */
	{0, 0, 0, 0, 0, 0},	/* 11367 */
	{0, 0, 0, 0, 0, 0},	/* 11368 */
	{0, 0, 0, 0, 0, 0},	/* 11369 */
	{0, 0, 0, 0, 0, 0},	/* 11370 */
	{0, 0, 0, 0, 0, 0},	/* 11371 */
	{0, 0, 0, 0, 0, 0},	/* 11372 */
	{0, 0, 0, 0, 0, 0},	/* 11373 */
	{0, 0, 0, 0, 0, 0},	/* 11374 */
	{0, 0, 0, 0, 0, 0},	/* 11375 */
	{0, 0, 0, 0, 0, 0},	/* 11376 */
	{0, 0, 0, 0, 0, 0},	/* 11377 */
	{0, 0, 0, 0, 0, 0},	/* 11378 */
	{0, 0, 0, 0, 0, 0},	/* 11379 */
	{0, 0, 0, 0, 0, 0},	/* 11380 */
	{0, 0, 0, 0, 0, 0},	/* 11381 */
	{0, 0, 0, 0, 0, 0},	/* 11382 */
	{0, 0, 0, 0, 0, 0},	/* 11383 */
	{0, 0, 0, 0, 0, 0},	/* 11384 */
	{0, 0, 0, 0, 0, 0},	/* 11385 */
	{0, 0, 0, 0, 0, 0},	/* 11386 */
	{0, 0, 0, 0, 0, 0},	/* 11387 */
	{0, 0, 0, 0, 0, 0},	/* 11388 */
	{0, 0, 0, 0, 0, 0},	/* 11389 */
	{0, 0, 0, 0, 0, 0},	/* 11390 */
	{0, 0, 0, 0, 0, 0},	/* 11553 */
	{0, 0, 0, 0, 0, 0},	/* 11554 */
	{0, 0, 0, 0, 0, 0},	/* 11555 */
	{0, 0, 0, 0, 0, 0},	/* 11556 */
	{0, 0, 0, 0, 0, 0},	/* 11557 */
	{0, 0, 0, 0, 0, 0},	/* 11558 */
	{0, 0, 0, 0, 0, 0},	/* 11559 */
	{0, 0, 0, 0, 0, 0},	/* 11560 */
	{0, 0, 0, 0, 0, 0},	/* 11561 */
	{0, 0, 0, 0, 0, 0},	/* 11562 */
	{0, 0, 0, 0, 0, 0},	/* 11563 */
	{0, 0, 0, 0, 0, 0},	/* 11564 */
	{0, 0, 0, 0, 0, 0},	/* 11565 */
	{0, 0, 0, 0, 0, 0},	/* 11566 */
	{0, 0, 0, 0, 0, 0},	/* 11567 */
	{0, 0, 0, 0, 0, 0},	/* 11568 */
	{0, 0, 0, 0, 0, 0},	/* 11569 */
	{0, 0, 0, 0, 0, 0},	/* 11570 */
	{0, 0, 0, 0, 0, 0},	/* 11571 */
	{0, 0, 0, 0, 0, 0},	/* 11572 */
	{0, 0, 0, 0, 0, 0},	/* 11573 */
	{0, 0, 0, 0, 0, 0},	/* 11574 */
	{0, 0, 0, 0, 0, 0},	/* 11575 */
	{0, 0, 0, 0, 0, 0},	/* 11576 */
	{0, 0, 0, 0, 0, 0},	/* 11577 */
	{0, 0, 0, 0, 0, 0},	/* 11578 */
	{0, 0, 0, 0, 0, 0},	/* 11579 */
	{0, 0, 0, 0, 0, 0},	/* 11580 */
	{0, 0, 0, 0, 0, 0},	/* 11581 */
	{0, 0, 0, 0, 0, 0},	/* 11582 */
	{0, 0, 0, 0, 0, 0},	/* 11583 */
	{0, 0, 0, 0, 0, 0},	/* 11584 */
	{0, 0, 0, 0, 0, 0},	/* 11585 */
	{0, 0, 0, 0, 0, 0},	/* 11586 */
	{0, 0, 0, 0, 0, 0},	/* 11587 */
	{0, 0, 0, 0, 0, 0},	/* 11588 */
	{0, 0, 0, 0, 0, 0},	/* 11589 */
	{0, 0, 0, 0, 0, 0},	/* 11590 */
	{0, 0, 0, 0, 0, 0},	/* 11591 */
	{0, 0, 0, 0, 0, 0},	/* 11592 */
	{0, 0, 0, 0, 0, 0},	/* 11593 */
	{0, 0, 0, 0, 0, 0},	/* 11594 */
	{0, 0, 0, 0, 0, 0},	/* 11595 */
	{0, 0, 0, 0, 0, 0},	/* 11596 */
	{0, 0, 0, 0, 0, 0},	/* 11597 */
	{0, 0, 0, 0, 0, 0},	/* 11598 */
	{0, 0, 0, 0, 0, 0},	/* 11599 */
	{0, 0, 0, 0, 0, 0},	/* 11600 */
	{0, 0, 0, 0, 0, 0},	/* 11601 */
	{0, 0, 0, 0, 0, 0},	/* 11602 */
	{0, 0, 0, 0, 0, 0},	/* 11603 */
	{0, 0, 0, 0, 0, 0},	/* 11604 */
	{0, 0, 0, 0, 0, 0},	/* 11605 */
	{0, 0, 0, 0, 0, 0},	/* 11606 */
	{0, 0, 0, 0, 0, 0},	/* 11607 */
	{0, 0, 0, 0, 0, 0},	/* 11608 */
	{0, 0, 0, 0, 0, 0},	/* 11609 */
	{0, 0, 0, 0, 0, 0},	/* 11610 */
	{0, 0, 0, 0, 0, 0},	/* 11611 */
	{0, 0, 0, 0, 0, 0},	/* 11612 */
	{0, 0, 0, 0, 0, 0},	/* 11613 */
	{0, 0, 0, 0, 0, 0},	/* 11614 */
	{0, 0, 0, 0, 0, 0},	/* 11615 */
	{0, 0, 0, 0, 0, 0},	/* 11616 */
	{0, 0, 0, 0, 0, 0},	/* 11617 */
	{0, 0, 0, 0, 0, 0},	/* 11618 */
	{0, 0, 0, 0, 0, 0},	/* 11619 */
	{0, 0, 0, 0, 0, 0},	/* 11620 */
	{0, 0, 0, 0, 0, 0},	/* 11621 */
	{0, 0, 0, 0, 0, 0},	/* 11622 */
	{0, 0, 0, 0, 0, 0},	/* 11623 */
	{0, 0, 0, 0, 0, 0},	/* 11624 */
	{0, 0, 0, 0, 0, 0},	/* 11625 */
	{0, 0, 0, 0, 0, 0},	/* 11626 */
	{0, 0, 0, 0, 0, 0},	/* 11627 */
	{0, 0, 0, 0, 0, 0},	/* 11628 */
	{0, 0, 0, 0, 0, 0},	/* 11629 */
	{0, 0, 0, 0, 0, 0},	/* 11630 */
	{0, 0, 0, 0, 0, 0},	/* 11631 */
	{0, 0, 0, 0, 0, 0},	/* 11632 */
	{0, 0, 0, 0, 0, 0},	/* 11633 */
	{0, 0, 0, 0, 0, 0},	/* 11634 */
	{0, 0, 0, 0, 0, 0},	/* 11635 */
	{0, 0, 0, 0, 0, 0},	/* 11636 */
	{0, 0, 0, 0, 0, 0},	/* 11637 */
	{0, 0, 0, 0, 0, 0},	/* 11638 */
	{0, 0, 0, 0, 0, 0},	/* 11639 */
	{0, 0, 0, 0, 0, 0},	/* 11640 */
	{0, 0, 0, 0, 0, 0},	/* 11641 */
	{0, 0, 0, 0, 0, 0},	/* 11642 */
	{0, 0, 0, 0, 0, 0},	/* 11643 */
	{0, 0, 0, 0, 0, 0},	/* 11644 */
	{0, 0, 0, 0, 0, 0},	/* 11645 */
	{0, 0, 0, 0, 0, 0},	/* 11646 */
	{0, 0, 0, 0, 0, 0},	/* 11809 */
	{0, 0, 0, 0, 0, 0},	/* 11810 */
	{0, 0, 0, 0, 0, 0},	/* 11811 */
	{0, 0, 0, 0, 0, 0},	/* 11812 */
	{0, 0, 0, 0, 0, 0},	/* 11813 */
	{0, 0, 0, 0, 0, 0},	/* 11814 */
	{0, 0, 0, 0, 0, 0},	/* 11815 */
	{0, 0, 0, 0, 0, 0},	/* 11816 */
	{0, 0, 0, 0, 0, 0},	/* 11817 */
	{0, 0, 0, 0, 0, 0},	/* 11818 */
	{0, 0, 0, 0, 0, 0},	/* 11819 */
	{0, 0, 0, 0, 0, 0},	/* 11820 */
	{0, 0, 0, 0, 0, 0},	/* 11821 */
	{0, 0, 0, 0, 0, 0},	/* 11822 */
	{0, 0, 0, 0, 0, 0},	/* 11823 */
	{0, 0, 0, 0, 0, 0},	/* 11824 */
	{0, 0, 0, 0, 0, 0},	/* 11825 */
	{0, 0, 0, 0, 0, 0},	/* 11826 */
	{0, 0, 0, 0, 0, 0},	/* 11827 */
	{0, 0, 0, 0, 0, 0},	/* 11828 */
	{0, 0, 0, 0, 0, 0},	/* 11829 */
	{0, 0, 0, 0, 0, 0},	/* 11830 */
	{0, 0, 0, 0, 0, 0},	/* 11831 */
	{0, 0, 0, 0, 0, 0},	/* 11832 */
	{0, 0, 0, 0, 0, 0},	/* 11833 */
	{0, 0, 0, 0, 0, 0},	/* 11834 */
	{0, 0, 0, 0, 0, 0},	/* 11835 */
	{0, 0, 0, 0, 0, 0},	/* 11836 */
	{0, 0, 0, 0, 0, 0},	/* 11837 */
	{0, 0, 0, 0, 0, 0},	/* 11838 */
	{0, 0, 0, 0, 0, 0},	/* 11839 */
	{0, 0, 0, 0, 0, 0},	/* 11840 */
	{0, 0, 0, 0, 0, 0},	/* 11841 */
	{0, 0, 0, 0, 0, 0},	/* 11842 */
	{0, 0, 0, 0, 0, 0},	/* 11843 */
	{0, 0, 0, 0, 0, 0},	/* 11844 */
	{0, 0, 0, 0, 0, 0},	/* 11845 */
	{0, 0, 0, 0, 0, 0},	/* 11846 */
	{0, 0, 0, 0, 0, 0},	/* 11847 */
	{0, 0, 0, 0, 0, 0},	/* 11848 */
	{0, 0, 0, 0, 0, 0},	/* 11849 */
	{0, 0, 0, 0, 0, 0},	/* 11850 */
	{0, 0, 0, 0, 0, 0},	/* 11851 */
	{0, 0, 0, 0, 0, 0},	/* 11852 */
	{0, 0, 0, 0, 0, 0},	/* 11853 */
	{0, 0, 0, 0, 0, 0},	/* 11854 */
	{0, 0, 0, 0, 0, 0},	/* 11855 */
	{0, 0, 0, 0, 0, 0},	/* 11856 */
	{0, 0, 0, 0, 0, 0},	/* 11857 */
	{0, 0, 0, 0, 0, 0},	/* 11858 */
	{0, 0, 0, 0, 0, 0},	/* 11859 */
	{0, 0, 0, 0, 0, 0},	/* 11860 */
	{0, 0, 0, 0, 0, 0},	/* 11861 */
	{0, 0, 0, 0, 0, 0},	/* 11862 */
	{0, 0, 0, 0, 0, 0},	/* 11863 */
	{0, 0, 0, 0, 0, 0},	/* 11864 */
	{0, 0, 0, 0, 0, 0},	/* 11865 */
	{0, 0, 0, 0, 0, 0},	/* 11866 */
	{0, 0, 0, 0, 0, 0},	/* 11867 */
	{0, 0, 0, 0, 0, 0},	/* 11868 */
	{0, 0, 0, 0, 0, 0},	/* 11869 */
	{0, 0, 0, 0, 0, 0},	/* 11870 */
	{0, 0, 0, 0, 0, 0},	/* 11871 */
	{0, 0, 0, 0, 0, 0},	/* 11872 */
	{0, 0, 0, 0, 0, 0},	/* 11873 */
	{0, 0, 0, 0, 0, 0},	/* 11874 */
	{0, 0, 0, 0, 0, 0},	/* 11875 */
	{0, 0, 0, 0, 0, 0},	/* 11876 */
	{0, 0, 0, 0, 0, 0},	/* 11877 */
	{0, 0, 0, 0, 0, 0},	/* 11878 */
	{0, 0, 0, 0, 0, 0},	/* 11879 */
	{0, 0, 0, 0, 0, 0},	/* 11880 */
	{0, 0, 0, 0, 0, 0},	/* 11881 */
	{0, 0, 0, 0, 0, 0},	/* 11882 */
	{0, 0, 0, 0, 0, 0},	/* 11883 */
	{0, 0, 0, 0, 0, 0},	/* 11884 */
	{0, 0, 0, 0, 0, 0},	/* 11885 */
	{0, 0, 0, 0, 0, 0},	/* 11886 */
	{0, 0, 0, 0, 0, 0},	/* 11887 */
	{0, 0, 0, 0, 0, 0},	/* 11888 */
	{0, 0, 0, 0, 0, 0},	/* 11889 */
	{0, 0, 0, 0, 0, 0},	/* 11890 */
	{0, 0, 0, 0, 0, 0},	/* 11891 */
	{0, 0, 0, 0, 0, 0},	/* 11892 */
	{0, 0, 0, 0, 0, 0},	/* 11893 */
	{0, 0, 0, 0, 0, 0},	/* 11894 */
	{0, 0, 0, 0, 0, 0},	/* 11895 */
	{0, 0, 0, 0, 0, 0},	/* 11896 */
	{0, 0, 0, 0, 0, 0},	/* 11897 */
	{0, 0, 0, 0, 0, 0},	/* 11898 */
	{0, 0, 0, 0, 0, 0},	/* 11899 */
	{0, 0, 0, 0, 0, 0},	/* 11900 */
	{0, 0, 0, 0, 0, 0},	/* 11901 */
	{0, 0, 0, 0, 0, 0},	/* 11902 */
	{0, 0, 0, 0, 0, 0},	/* 12065 */
	{0, 0, 0, 0, 0, 0},	/* 12066 */
	{0, 0, 0, 0, 0, 0},	/* 12067 */
	{0, 0, 0, 0, 0, 0},	/* 12068 */
	{0, 0, 0, 0, 0, 0},	/* 12069 */
	{0, 0, 0, 0, 0, 0},	/* 12070 */
	{0, 0, 0, 0, 0, 0},	/* 12071 */
	{0, 0, 0, 0, 0, 0},	/* 12072 */
	{0, 0, 0, 0, 0, 0},	/* 12073 */
	{0, 0, 0, 0, 0, 0},	/* 12074 */
	{0, 0, 0, 0, 0, 0},	/* 12075 */
	{0, 0, 0, 0, 0, 0},	/* 12076 */
	{0, 0, 0, 0, 0, 0},	/* 12077 */
	{0, 0, 0, 0, 0, 0},	/* 12078 */
	{0, 0, 0, 0, 0, 0},	/* 12079 */
	{0, 0, 0, 0, 0, 0},	/* 12080 */
	{0, 0, 0, 0, 0, 0},	/* 12081 */
	{0, 0, 0, 0, 0, 0},	/* 12082 */
	{0, 0, 0, 0, 0, 0},	/* 12083 */
	{0, 0, 0, 0, 0, 0},	/* 12084 */
	{0, 0, 0, 0, 0, 0},	/* 12085 */
	{0, 0, 0, 0, 0, 0},	/* 12086 */
	{0, 0, 0, 0, 0, 0},	/* 12087 */
	{0, 0, 0, 0, 0, 0},	/* 12088 */
	{0, 0, 0, 0, 0, 0},	/* 12089 */
	{0, 0, 0, 0, 0, 0},	/* 12090 */
	{0, 0, 0, 0, 0, 0},	/* 12091 */
	{0, 0, 0, 0, 0, 0},	/* 12092 */
	{0, 0, 0, 0, 0, 0},	/* 12093 */
	{0, 0, 0, 0, 0, 0},	/* 12094 */
	{0, 0, 0, 0, 0, 0},	/* 12095 */
	{0, 0, 0, 0, 0, 0},	/* 12096 */
	{0, 0, 0, 0, 0, 0},	/* 12097 */
	{0, 0, 0, 0, 0, 0},	/* 12098 */
	{0, 0, 0, 0, 0, 0},	/* 12099 */
	{0, 0, 0, 0, 0, 0},	/* 12100 */
	{0, 0, 0, 0, 0, 0},	/* 12101 */
	{0, 0, 0, 0, 0, 0},	/* 12102 */
	{0, 0, 0, 0, 0, 0},	/* 12103 */
	{0, 0, 0, 0, 0, 0},	/* 12104 */
	{0, 0, 0, 0, 0, 0},	/* 12105 */
	{0, 0, 0, 0, 0, 0},	/* 12106 */
	{0, 0, 0, 0, 0, 0},	/* 12107 */
	{0, 0, 0, 0, 0, 0},	/* 12108 */
	{0, 0, 0, 0, 0, 0},	/* 12109 */
	{0, 0, 0, 0, 0, 0},	/* 12110 */
	{0, 0, 0, 0, 0, 0},	/* 12111 */
	{0, 0, 0, 0, 0, 0},	/* 12112 */
	{0, 0, 0, 0, 0, 0},	/* 12113 */
	{0, 0, 0, 0, 0, 0},	/* 12114 */
	{0, 0, 0, 0, 0, 0},	/* 12115 */
	{0, 0, 0, 0, 0, 0},	/* 12116 */
	{0, 0, 0, 0, 0, 0},	/* 12117 */
	{0, 0, 0, 0, 0, 0},	/* 12118 */
	{0, 0, 0, 0, 0, 0},	/* 12119 */
	{0, 0, 0, 0, 0, 0},	/* 12120 */
	{0, 0, 0, 0, 0, 0},	/* 12121 */
	{0, 0, 0, 0, 0, 0},	/* 12122 */
	{0, 0, 0, 0, 0, 0},	/* 12123 */
	{0, 0, 0, 0, 0, 0},	/* 12124 */
	{0, 0, 0, 0, 0, 0},	/* 12125 */
	{0, 0, 0, 0, 0, 0},	/* 12126 */
	{0, 0, 0, 0, 0, 0},	/* 12127 */
	{0, 0, 0, 0, 0, 0},	/* 12128 */
	{0, 0, 0, 0, 0, 0},	/* 12129 */
	{0, 0, 0, 0, 0, 0},	/* 12130 */
	{0, 0, 0, 0, 0, 0},	/* 12131 */
	{0, 0, 0, 0, 0, 0},	/* 12132 */
	{0, 0, 0, 0, 0, 0},	/* 12133 */
	{0, 0, 0, 0, 0, 0},	/* 12134 */
	{0, 0, 0, 0, 0, 0},	/* 12135 */
	{0, 0, 0, 0, 0, 0},	/* 12136 */
	{0, 0, 0, 0, 0, 0},	/* 12137 */
	{0, 0, 0, 0, 0, 0},	/* 12138 */
	{0, 0, 0, 0, 0, 0},	/* 12139 */
	{0, 0, 0, 0, 0, 0},	/* 12140 */
	{0, 0, 0, 0, 0, 0},	/* 12141 */
	{0, 0, 0, 0, 0, 0},	/* 12142 */
	{0, 0, 0, 0, 0, 0},	/* 12143 */
	{0, 0, 0, 0, 0, 0},	/* 12144 */
	{0, 0, 0, 0, 0, 0},	/* 12145 */
	{0, 0, 0, 0, 0, 0},	/* 12146 */
	{0, 0, 0, 0, 0, 0},	/* 12147 */
	{0, 0, 0, 0, 0, 0},	/* 12148 */
	{0, 0, 0, 0, 0, 0},	/* 12149 */
	{0, 0, 0, 0, 0, 0},	/* 12150 */
	{0, 0, 0, 0, 0, 0},	/* 12151 */
	{0, 0, 0, 0, 0, 0},	/* 12152 */
	{0, 0, 0, 0, 0, 0},	/* 12153 */
	{0, 0, 0, 0, 0, 0},	/* 12154 */
	{0, 0, 0, 0, 0, 0},	/* 12155 */
	{0, 0, 0, 0, 0, 0},	/* 12156 */
	{0, 0, 0, 0, 0, 0},	/* 12157 */
	{0, 0, 0, 0, 0, 0},	/* 12158 */
	{1, 13, 14, 11, 1, 0},	/* 12321 */
	{1, 14, 14, 11, 1, 0},	/* 12322 */
	{1, 14, 14, 12, 2, 0},	/* 12323 */
	{2, 14, 14, 11, 2, 0},	/* 12324 */
	{1, 14, 14, 12, 2, 0},	/* 12325 */
	{1, 14, 14, 12, 2, 0},	/* 12326 */
	{1, 14, 14, 12, 2, 0},	/* 12327 */
	{1, 14, 14, 12, 2, 0},	/* 12328 */
	{1, 14, 14, 12, 2, 0},	/* 12329 */
	{1, 14, 14, 12, 2, 0},	/* 12330 */
	{1, 14, 14, 12, 2, 0},	/* 12331 */
	{1, 14, 14, 12, 2, 0},	/* 12332 */
	{1, 14, 14, 11, 2, 0},	/* 12333 */
	{1, 14, 14, 12, 2, 0},	/* 12334 */
	{1, 14, 14, 12, 2, 0},	/* 12335 */
	{1, 14, 14, 12, 2, 0},	/* 12336 */
	{1, 14, 14, 12, 2, 0},	/* 12337 */
	{1, 14, 14, 12, 2, 0},	/* 12338 */
	{1, 14, 14, 12, 2, 0},	/* 12339 */
	{1, 14, 14, 12, 2, 0},	/* 12340 */
	{1, 14, 14, 11, 1, 0},	/* 12341 */
	{1, 14, 14, 12, 2, 0},	/* 12342 */
	{1, 14, 14, 12, 2, 0},	/* 12343 */
	{1, 14, 14, 12, 2, 0},	/* 12344 */
	{1, 14, 14, 12, 2, 0},	/* 12345 */
	{1, 14, 14, 12, 2, 0},	/* 12346 */
	{1, 14, 14, 12, 2, 0},	/* 12347 */
	{1, 13, 14, 12, 2, 0},	/* 12348 */
	{1, 14, 14, 12, 2, 0},	/* 12349 */
	{1, 14, 14, 12, 2, 0},	/* 12350 */
	{1, 14, 14, 12, 2, 0},	/* 12351 */
	{1, 14, 14, 11, 2, 0},	/* 12352 */
	{1, 14, 14, 12, 2, 0},	/* 12353 */
	{1, 14, 14, 12, 2, 0},	/* 12354 */
	{1, 14, 14, 12, 2, 0},	/* 12355 */
	{1, 14, 14, 12, 2, 0},	/* 12356 */
	{1, 14, 14, 12, 2, 0},	/* 12357 */
	{1, 14, 14, 12, 2, 0},	/* 12358 */
	{2, 13, 14, 11, 2, 0},	/* 12359 */
	{1, 14, 14, 12, 2, 0},	/* 12360 */
	{1, 14, 14, 12, 2, 0},	/* 12361 */
	{1, 14, 14, 12, 2, 0},	/* 12362 */
	{1, 14, 14, 12, 2, 0},	/* 12363 */
	{1, 14, 14, 12, 2, 0},	/* 12364 */
	{1, 14, 14, 12, 2, 0},	/* 12365 */
	{1, 14, 14, 12, 2, 0},	/* 12366 */
	{2, 13, 14, 11, 2, 0},	/* 12367 */
	{1, 14, 14, 12, 2, 0},	/* 12368 */
	{1, 14, 14, 12, 2, 0},	/* 12369 */
	{1, 14, 14, 12, 2, 0},	/* 12370 */
	{1, 14, 14, 12, 2, 0},	/* 12371 */
	{1, 14, 14, 12, 2, 0},	/* 12372 */
	{1, 14, 14, 12, 2, 0},	/* 12373 */
	{1, 14, 14, 12, 2, 0},	/* 12374 */
	{1, 13, 14, 11, 2, 0},	/* 12375 */
	{1, 14, 14, 12, 2, 0},	/* 12376 */
	{1, 14, 14, 12, 2, 0},	/* 12377 */
	{1, 14, 14, 11, 2, 0},	/* 12378 */
	{1, 14, 14, 11, 2, 0},	/* 12379 */
	{1, 14, 14, 12, 2, 0},	/* 12380 */
	{1, 14, 14, 12, 2, 0},	/* 12381 */
	{1, 14, 14, 12, 2, 0},	/* 12382 */
	{2, 13, 14, 11, 2, 0},	/* 12383 */
	{1, 14, 14, 12, 2, 0},	/* 12384 */
	{1, 14, 14, 12, 2, 0},	/* 12385 */
	{1, 14, 14, 11, 2, 0},	/* 12386 */
	{1, 14, 14, 12, 2, 0},	/* 12387 */
	{1, 14, 14, 12, 2, 0},	/* 12388 */
	{2, 14, 14, 11, 2, 0},	/* 12389 */
	{1, 14, 14, 12, 2, 0},	/* 12390 */
	{1, 14, 14, 12, 2, 0},	/* 12391 */
	{1, 14, 14, 12, 2, 0},	/* 12392 */
	{1, 14, 14, 12, 2, 0},	/* 12393 */
	{1, 14, 14, 12, 2, 0},	/* 12394 */
	{1, 14, 14, 12, 2, 0},	/* 12395 */
	{1, 14, 14, 6, -5, 0},	/* 12396 */
	{1, 14, 14, 12, 2, 0},	/* 12397 */
	{1, 14, 14, 12, 2, 0},	/* 12398 */
	{1, 14, 14, 12, 2, 0},	/* 12399 */
	{1, 14, 14, 12, 2, 0},	/* 12400 */
	{1, 14, 14, 12, 2, 0},	/* 12401 */
	{1, 14, 14, 12, 2, 0},	/* 12402 */
	{1, 13, 14, 12, 2, 0},	/* 12403 */
	{1, 14, 14, 12, 2, 0},	/* 12404 */
	{2, 13, 14, 12, 2, 0},	/* 12405 */
	{1, 13, 14, 11, 2, 0},	/* 12406 */
	{2, 13, 14, 11, 2, 0},	/* 12407 */
	{2, 13, 14, 11, 2, 0},	/* 12408 */
	{1, 13, 14, 12, 2, 0},	/* 12409 */
	{1, 12, 14, 12, 2, 0},	/* 12410 */
	{1, 14, 14, 12, 2, 0},	/* 12411 */
	{1, 14, 14, 12, 2, 0},	/* 12412 */
	{1, 14, 14, 12, 2, 0},	/* 12413 */
	{1, 14, 14, 12, 2, 0},	/* 12414 */
};
static XFontProp props[] = {
	{XA_COPYRIGHT, 0},
	{XA_RESOLUTION, 75},
};

char	*xtfont2cpright = "Public domain font.  Share and enjoy.";

XFontStruct xtfont2 = {
	(XExtData*)0,
	(Font)0,
	FontLeftToRight,	/* direction */
	33,	/* min_byte2 */
	126,	/* max_byte2 */
	33,	/* min_byte1 */
	48,	/* max_byte1 */
	0,	/* all chars exist */
	0,	/* default char */
	2,	/* n_properties */
	props,
	{0, 0, 14, -1, -11, 0},
	{10, 14, 14, 12, 2, 0},
	perchar,
	12,	/* font ascent */
	2,	/* font descent */
};
