Copyright (c) 2005 X.Org Foundation L.L.C.

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
$Header: /cvs/xtest/xtest/xts5/tset/Xlib14/wctlttp/wctlttp.m,v 1.1.1.2 2005/04/15 14:05:20 anderson Exp $

Copyright (c) Applied Testing and Technology, Inc. 1993, 1994, 1995
Copyright (c) 88open Consortium, Ltd. 1990, 1991, 1992, 1993
All Rights Reserved.

>># 
>># Project: VSW5
>># 
>># File: tset/Xlib14/wctlttp/wctlttp.m
>># 
>># Description:
>>#	Tests for XwcTextListToTextProperty()
>># 
>># Modifications:
>># $Log: wctlttp.m,v $
>># Revision 1.1.1.2  2005/04/15 14:05:20  anderson
>># Reimport of the base with the legal name in the copyright fixed.
>>#
>># Revision 8.0  1998/12/23 23:39:12  mar
>># Branch point for Release 5.0.2
>>#
>># Revision 7.0  1998/10/30 23:02:19  mar
>># Branch point for Release 5.0.2b1
>>#
>># Revision 6.0  1998/03/02 05:30:12  tbr
>># Branch point for Release 5.0.1
>>#
>># Revision 5.0  1998/01/26 03:26:46  tbr
>># Branch point for Release 5.0.1b1
>>#
>># Revision 4.0  1995/12/15 09:24:49  tbr
>># Branch point for Release 5.0.0
>>#
>># Revision 3.1  1995/12/15  02:02:30  andy
>># Prepare for GA Release
>>#
>>AVSCODE
>>TITLE XwcTextListToTextProperty Xlib14
void
XwcTextListToTextProperty()
>>EXTERN

/******
 * User defined globals for test
 ******/

wchar_t string_good[10][26] ;
wchar_t *string_list[10];
int length_good = 39 ;

/******
 * User defined globals for test case sets
 ******/
Display	   *display_good;
                                
/******
 * generated globals
 ******/
char *exec_file_name;
int x_init,
    y_init,
    w_init,
    h_init;

/******
 * routines
 ******/


/*****
 * routine to modify saved information prior to chekstat call
 *****/
mod_stat()
{
	extern Display *dpy_save;
	extern Window wid_save;
	extern Pixmap pid_save;
	extern GC gc_save;
	extern XWindowAttributes wat_save;

	/*
	 * insert modifications to saved data here
	 */
}

/*****
 * svcwcTextListToTextProperty routine 
 *****/                             
svcwcTextListToTextProperty(display, list_good, count_good,
		   style_good, text_prop_good )
Display     *display ;
wchar_t     *list_good[];
int		count_good;
XICCEncodingStyle style_good;
XTextProperty	text_prop_good;
{
        extern int  errcnt;
        extern int  errflg;
        extern int  chkflg;
	extern int  signal_status();
	extern int  unexp_err();
	extern char *svc_user_arg;
	extern char *strcpy();

	char fmtstr[256], *call_string;
	union msglst fmt_lst[1];        
        int skip_pixcheck;
        Status ret_status ;

	int
		ss_status,	/* save stat return status */	
		stat_status,	/* check stat return status */
  		setup_status,
  		cleanup_status,
		i1;


	regr_args.l_flags.bufrout = 1;

	/* buffer display struct info for error checking */
	bufrdisp(display_good);	
	                  
	/* set number of iterations to 1.	*/ 
	if (regr_args.iter == 0)   
	    regr_args.iter = 1;	

	if (regr_args.l_flags.setup) 
		setup_status = REGR_NORMAL;
	XSync(display_arg, 0);

	if (regr_args.l_flags.chksta  == 1)
		ss_status = save_stat(dpy_msk, gc_id,
		       display_arg, drawable_id);
				
	first_error = 0;	/* no errors encountered yet */

	errflg = 0;
	XSetErrorHandler(signal_status);

	ret_status = XwcTextListToTextProperty(
		 display, (wchar_t **)list_good,
		 count_good, style_good, &text_prop_good);

	XSync(display_arg, 0);
	XSetErrorHandler(unexp_err);          
	/* no colormap by default */
	r_wait(display_arg, window_arg, time_delay, None);	

	mod_stat();

	if (regr_args.l_flags.chksta  == 1) 
		stat_status = chek_stat (dpy_msk ,
			 gc_id, display_arg, drawable_id,
			 ss_status);
	else                              
		stat_status = REGR_NORMAL;

	if ((!errflg) && (!chkflg)) 
		if ((badstat(display_arg, estatus, Success)) != REGR_NORMAL)
    			errflg = 1;

	if ((regr_args.l_flags.check) && 
		(errflg == 0) && 
		(stat_status == REGR_NORMAL)) 
	{
		tet_infoline("TEST: Call succeded");
		if (ret_status == Success) 
		{
			tet_infoline("TEST: Values of property returned");
    			check_str("Tst", text_prop_good.value, "string") ;
    			check_dec(length_good, text_prop_good.nitems, "nitems") ;
		} 
		else
		{
    			errflg = 1 ;
    			message("XwcTextListToTextProperty failed: Expected Success\n", NULL, 0);
		}
	}
	XSync(display_arg, 0);

	if (regr_args.l_flags.cleanup)
		cleanup_status = REGR_NORMAL;
	XSync(display_arg, 0);

	/* if there was an error ...     */
	if (errflg) 
	{ 	
		errcnt++;   /* ...increment the error count  */
		tet_result(TET_FAIL);
        }

	chkflg = 0;
  	regr_args.l_flags.bufrout = 0;

        dumpbuf();
}


>>ASSERTION Good C
If the implementation is X11R5 or later:
A call to 
xname
shall convert an internationalized wide-character text list to a
list property structure and return Success.
>>CODE
#if XT_X_RELEASE > 4
int ret;
#endif

#if XT_X_RELEASE > 4

	display_arg = Dsp;
/*
 * Create a GC to save environmental data in
 */
	gc_save = XCreateGC(display_arg,XRootWindow(display_arg,XDefaultScreen(display_arg)),(unsigned long)0,(XGCValues *)0);

	regr_args.l_flags.check = 0;
	regr_args.l_flags.nostat = 0;
	regr_args.l_flags.perf = 0;
	regr_args.l_flags.setup = 0;
	regr_args.l_flags.cleanup = 0;
	regr_args.l_flags.chksta = 0;
	regr_args.l_flags.chkdpy = 0;
	regr_args.l_flags.verbose = 0;
	regr_args.iter = 1;		/* execute service once			*/
	estatus[0] = 1;


/******
 * User defined initialization code for test case sets
 ******/
	display_good = display_arg;

	estatus[0] = 1;
	estatus[1] = Success;

	if ((regr_args.l_flags.good == 0) || (estatus[1] == Success)) 
	{
		tet_infoline("TEST: Set text list to XTextProperty structure");
                regr_args.l_flags.setup = 1;
                regr_args.l_flags.cleanup = 1;
                regr_args.l_flags.check = 1;
                regr_args.l_flags.chksta = 1;

                {
			int i ;
			XTextProperty 	text_prop ;
			int count = 1;

        		memset(string_good, 0, sizeof(string_good));
                    	for (i = 0 ; i < 10 ; i++)
			{
        			ret = mbstowcs((wchar_t *)string_good[i], "Tst", 5);
        			if (ret == -1)
        			{
					tet_infoline("ERROR: Error in making a wide character string");
                			tet_result(TET_FAIL);
					return;
        			}
				string_list[i] = &string_good[i][0];
			}
			svcwcTextListToTextProperty(
				display_good, string_list,
				10, (XICCEncodingStyle)XTextStyle, 
				&text_prop);
                }
	}
	tet_result(TET_PASS);
#else

	tet_infoline("INFO: Implementation not X11R5 or greater");
	tet_result(TET_UNSUPPORTED);
#endif
