Copyright (c) 2005 X.Org Foundation L.L.C.

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
of the Software, and to permit persons to whom the Software is furnished to do
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
$Header: /cvs/xtest/xtest/xts5/tset/Xt11/toffset/toffset.m,v 1.1.1.2 2005/04/15 14:06:07 anderson Exp $

Copyright (c) Applied Testing and Technology, Inc. 1993, 1994, 1995
Copyright (c) 88open Consortium, Ltd. 1990, 1991, 1992, 1993
All Rights Reserved.

>># 
>># Project: VSW5
>># 
>># File: tset/Xt11/toffset/toffset.m
>># 
>># Description:
>>#	Tests for XtOffset()
>># 
>># Modifications:
>># $Log: toffset.m,v $
>># Revision 1.1.1.2  2005/04/15 14:06:07  anderson
>># Reimport of the base with the legal name in the copyright fixed.
>>#
>># Revision 8.0  1998/12/23 23:37:23  mar
>># Branch point for Release 5.0.2
>>#
>># Revision 7.0  1998/10/30 23:00:19  mar
>># Branch point for Release 5.0.2b1
>>#
>># Revision 6.0  1998/03/02 05:28:28  tbr
>># Branch point for Release 5.0.1
>>#
>># Revision 5.0  1998/01/26 03:25:02  tbr
>># Branch point for Release 5.0.1b1
>>#
>># Revision 4.0  1995/12/15 09:19:19  tbr
>># Branch point for Release 5.0.0
>>#
>># Revision 3.1  1995/12/15  02:13:58  andy
>># Prepare for GA Release
>>#
>>EXTERN
#include <X11/IntrinsicP.h>
#include <X11/ConstrainP.h>
#include <X11/CoreP.h>

int avs2;

XtAppContext app_ctext;
Widget topLevel, panedw, boxw1, boxw2;
Widget labelw, rowcolw, click_quit;
>>TITLE XtOffset Xt11
Cardinal
XtOffset(pointer_type, field_name)
>>ASSERTION Good A
A successful call to 
Cardinal XtOffset(pointer_type, field_name)
shall return the byte offset of the member
.A field_name 
within the structure type pointed to by
.A pointer_type.
>>CODE
char label[80];
char string[10];
typedef struct {
	int	dumb;
	char	dumb2;
} *teststruct;

	tet_infoline("TEST: XtOffset returns correct offset");
	if (XtOffset(teststruct, dumb) != 0) {
		sprintf(ebuf, "ERROR: Expected offset = 0, received %d", XtOffset(teststruct, dumb2));
		tet_infoline(ebuf);
		tet_result(TET_FAIL);
	}
	if (XtOffset(teststruct, dumb2) != sizeof(int)) {
		sprintf(ebuf, "ERROR: Expected offset = %d, received %d", sizeof(int), XtOffset(teststruct, dumb2));
		tet_infoline(ebuf);
		tet_result(TET_FAIL);
	}
	tet_result(TET_PASS);
